//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:ATmega328_ONDO2.c
//
//@XCb`̓vO
//@@oaPŁ@nmŁfkfɂȂ@||@ocRihmsPjŁ@nmŁfkfɂȂ
//
//@kdc
//@@oaOFgœ_Akŏ
//
//@x́@crPWaQOŎ擾
//@@ocVFcrPWaQO@PANZXrbg
//
//@ZX `^c̒lā@L𔻒肷
//@@L̔l͂bot̂ddoqnl̏ŕύXłi܂j
//@@`cbOFZT[̓dl
//@@ocTFZT[Ɂfgf^rbg
//
//@A^CNbN̖pXőԊu߂
//@@hmsOiocQjFpX
//
//@[hɓɂ̓fBbvXCb`P̌Č߂
//@@ocRFfBbvXCb`Pifkfłnmj@||@ocSFfBbvXCb`Pifkfłnmj
//
//@ʐM[hɓɂ̓fBbvXCb`Q̌Č߂
//@@ocSFfBbvXCb`Qifkfłnmj@||@ocUFfBbvXCb`Qifkfłnmj
//
//@A^CNbN͂hQbŃANZX
//@Oddoqnl͂hQbŃANZX
//@kbc͂hQbŃANZX
//@@rc`iobSjFhQbf[^C
//@@rbkiobTjFhQbNbNC
//
//@ʐM̓VAʐMōs
//@@ftHg͂SWOOCWCmCP
//@@x͂bot̂ddoqnl̏ŕύXłi܂j
//@@qwciocOjFMf[^
//@@swciocPjFMf[^
//
//@hQbkbc\̓dnm^neeo
//@@oaPŁ@fkfłnmAfgfłnee
//
//	
//@@N@XCb`Ắ@펞kbc\B
//@@@@@@@ĂȂ́@莞@XCb`ĂƂkbc\sA
//@@@@@@@̑^C~O܂ŕ\𑱂Bi̎̃XCb`M̓pXƂčlj
//@@@A@ݒ胂[hɌ
//@@@@kbc\ÃXCb`ꂽ́A
//@@@@ZxőɂĂkbc\n߂B
//
//@@A^CNbÑ̖pX
//@@@xƁ@̗͂̐L@ddoqnlɊi[B
//
//@@N@fBbvrvQnm̎́@ʐM[hɂȂA
//@@@VAʐM̃R}hɓB
//
//@@N@fBbvrvPnm̎́@[hɂȂA
//@@@Oddoqnl̊i[ꏊNAB
//
//@@N@fBbvrvPƃfBbvrvQ̗nm̎
//@@@ݒ胂[hɂȂ@臒l̐ݒsB
//
//
//
// 2013/03/17 Ver 0.02
//    ݒ胂[h@`^cl̕\ǉ
//    ݒlύXʂ̍ŏ ^Cg\ǉ
//    oxݒ莞@݂̐ZT[l̕\ǉ
//
//
//
//
//
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2012/11/19 Taishi  New (TAB4)
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"gei_eeprom.h"
#include	"timer.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"lcd.h"
#include	"uart.h"
#include	"port_bit.h"
#include	"settei.h"
#include	"display.h"
#include	"proc_init.h"
#include	"proc_comm.h"
#include	"Save_Dt.h"
#include	"Mega_Twi.h"
#include	"Rtc_Rx8025.h"
#include	"ondo_mizu.h"
#include	"a_d.h"
#include	"Seeprom.h"


#ifdef		HARD_TEST
static	unsigned char	ebf_read[8];
static	unsigned char	ebf_write[8];
#endif		//HARD_TEST

//*****************************************
// Main
//*****************************************
int	main(void)
{
#ifdef		HARD_TEST
	unsigned char	i;
#endif		//HARD_TEST
	unsigned char	j;
	unsigned short	us = 0;
	unsigned short	wpt = 0xffff;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	PORTB |= (1 << PB1);																					// PB1 Pullup
	DDRB = ((1 << DDB0) | (1 << DDB1)  | (1 << DDB2)| (1 << DDB3) | (1 << DDB4) | (1 << DDB5));				// PB0--5:Output
	DDRC = ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) );										// PC0--3:Output
	DDRD = ((1 << DDD1) | (1 << DDD5) );																	// PD0,PD2,PD3,PD4,PD6,PD7:Input, PD1,PD5:Output

	delay_ms(200);												// 200mS Delay

	twi_init();													// TWI ݒ
	read_config();												// ۑݒl̓ǂݏo

#ifdef		HARD_TEST
// ***************** Hard Check **** strat ***********
	// LED Check@kdcPO_ł
	for(i=0;i<10;i++){
		led_on_off(1);							// LED ON
		delay_ms(500);							// 500mS Delay
		led_on_off(0);							// LED OFF
		delay_ms(500);							// 500mS Delay
	}

	// LED Check@kdcT񑬂_ł
	for(i=0;i<5;i++){
		led_on_off(1);							// LED ON
		delay_ms(100);							// 100mS Delay
		led_on_off(0);							// LED OFF
		delay_ms(100);							// 100mS Delay
	}

	// Switch Check@TbԂ̓XCb`͂łkdcnm^nee
	for(i=0;i<250;i++){
		delay_ms(20);							// 20mS Delay
		j = ((~PIND) & SW_LCD);					// ]ăXCb`f[^擾
		if(j != 0){								// XCb`
			led_on_off(1);						// LED ON
		}else if(j == 0){						// XCb`
			led_on_off(0);						// LED OFF
		}
	}
	wait_sw_off();								// Q̃XCb`Q@܂ŉiv[v
	led_on_off(0);								// LED OFF

	uart_init();								// UART Initial
	get_pgm_str(&str_title_1[0]);				// vÖ̕("Geiger Counter")擾
	uart_tx_str_crlf("");						// UART TxD String + CR + LF
	uart_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
	init_lcd();									// Init. LCD
	disp_lcd(0, 0, disp_moji);					// display LCD(16char x 2Line) Up Side

	led_on_off(1);								// LED ON
	seep1025_read_8(0x10, (void *)ebf_read);
	gRTC_sec  = ebf_read[0];					// qsb b̃f[^ (BCD 0--59)
	gRTC_min  = ebf_read[1];					// qsb ̃f[^ (BCD 0--59)
	gRTC_hou  = ebf_read[2];					// qsb ̃f[^ (BCD 0--23j
	gRTC_wday = ebf_read[3];					// qsb j̃f[^ (BCD 1--7)
	gRTC_day  = ebf_read[4];					// qsb ̃f[^ (BCD 1--31)
	gRTC_mon  = ebf_read[5];					// qsb ̃f[^ (BCD 1--12j
	gRTC_year = ebf_read[6];					// qsb Ñf[^ (BCD 0--99)
	disp_md_hms();								// \
	delay_ms(4000);								// 4000mS Delay
	led_on_off(0);								// LED OFF

	Timer2_init();								// Timer2 Initial
	rtc_init();									//  qsb̏ݒ
	tim_10ms_led = 50;							// TOOrɃZbg
	disp_lcd(0, 1, (unsigned char *)"A/D:");	// display LCD(16char x 2Line) Down Side

	rtc_read();									// RTC N ǂݏo
	disp_md_hms();								// \

	i = 0;
	led_on_off(0);								// LED ON
	twi_close();								// TWI gpI
	sei();										// 荞݉
	for(j=0;;j++){
		if(tim_10ms_led == 0){
			tim_10ms_led = 100;							// POOrɃZbg
			mizu_initial();								// SencepfgfMo & A/D 0 Initial
			delay_ms(100);								// 100mS Delay
			us = ad0_get_one_data();					//  f[^擾
			mizu_close();								// SencepfLfMo & A/D 0 Close
			wtod_05u((char *)&disp_moji[0], us);
			uart_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF

			twi_init();									// TWI ݒ
			disp_lcd(4, 1, &disp_moji[1]);				// display LCD(16char x 2Line) Down Side

			rtc_read();									// RTC N ǂݏo
			disp_md_hms();								// N\
			twi_close();								// TWI gpI

		}

		if(rtc_1h_flg != 0){							// qsbĂ鎞̂PԌoߗp
			twi_init();									// TWI ݒ
			rtc_inta_clear();							// RTC /INTA M̃NA
			rtc_1h_flg = 0;

			led_on_off(1);								// LED ON

			rtc_read();									// RTC N ǂݏo
			twi_close();								// TWI gpI

			wtod_02x((char *)disp_moji,gRTC_year);		// N
			uart_tx_str("20");
			uart_tx_str((char *)&disp_moji[0]);			// UART TxD String
			uart_tx_str("/");
			wtod_02x((char *)disp_moji,gRTC_mon);		// 
			uart_tx_str((char *)&disp_moji[0]);			// UART TxD String
			uart_tx_str("/");
			wtod_02x((char *)disp_moji,gRTC_day);		// 
			uart_tx_str((char *)&disp_moji[0]);			// UART TxD String
			uart_tx_str(" ");
			wtod_02x((char *)disp_moji,gRTC_hou);		// 
			uart_tx_str((char *)&disp_moji[0]);			// UART TxD String
			uart_tx_str(":");							// UART TxD String
			wtod_02x((char *)disp_moji,gRTC_min);		// 
			uart_tx_str((char *)&disp_moji[0]);			// UART TxD String
			uart_tx_str(":");							// UART TxD String
			wtod_02x((char *)disp_moji,gRTC_sec);		// b
			uart_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String

			delay_ms(100);								// 100mS Delay
			led_on_off(0);								// LED OFF

			EIMSK |= (1 << INT0);						// INT0 Interrupt Enable
		}

		get_sw();
		if((sw[2] & SW_LCD) != 0){
			ebf_write[0] = gRTC_sec;					// qsb b̃f[^ (BCD 0--59)
			ebf_write[1] = gRTC_min;					// qsb ̃f[^ (BCD 0--59)
			ebf_write[2] = gRTC_hou;					// qsb ̃f[^ (BCD 0--23j
			ebf_write[3] = gRTC_wday;					// qsb j̃f[^ (BCD 1--7)
			ebf_write[4] = gRTC_day;					// qsb ̃f[^ (BCD 1--31)
			ebf_write[5] = gRTC_mon;					// qsb ̃f[^ (BCD 1--12j
			ebf_write[6] = gRTC_year;					// qsb Ñf[^ (BCD 0--99)
			twi_init();									// TWI ݒ
			seep1025_write_8(0x10, (void *)ebf_write);

			led_on_off(1);								// LED ON
			us = get_ondo_mizu();						// ݂̉xƐ̗L擾
			wtod_04x((char *)&disp_moji[0], us);
			disp_lcd(10, 1, &disp_moji[0]);				// display LCD(16char x 2Line) Down Side
			twi_close();								// TWI gpI

			delay_ms(100);								// 100mS Delay
			led_on_off(0);								// LED OFF
		}
	}



// ***************** Hard Check **** end ***********
#endif		//HARD_TEST

	// LED
	led_on_off(1);												// LED ON
	delay_ms(500);												// 500mS Delay
	led_on_off(0);												// LED OFF

	lcd_active = 0;												// ŏ͂kbcƂ
	j = ((~PIND) & SW_LCD);										// ]ăXCb`f[^擾
	if(j != 0){													// XCb`Ă鎞
		delay_ms(20);											// 20mS Delay
		j = ((~PINB) & SW_LCD);									// ]ăXCb`f[^擾
		if(j != 0){												// QxƂĂ鎞
			lcd_active = 1;										// kbcLƂ
		}
	}


	rtc_init();													//  qsb̏ݒ
	if(lcd_active == 1){										// kbcL̎
		init_lcd();												// kbcݒ
	}

	j = ((~PIND) & (DIPSW_INIT |DIPSW_COMM));					// ]ăfBbvXCb`f[^擾
	if(j == (DIPSW_INIT |DIPSW_COMM)){							// fBbvXCb`|PƂQnmĂ鎞
		delay_ms(20);											// 20mS Delay
		j = ((~PIND) & (DIPSW_INIT |DIPSW_COMM));				// ]ăfBbvXCb`f[^擾
		if(j == (DIPSW_INIT |DIPSW_COMM)){						// QxƂnmĂ鎞
			select_config_savedata();							// ݒlύXiiv[vj
		}
	}

	j = ((~PIND) & DIPSW_INIT);									// ]ăfBbvXCb`f[^擾
	if(j != 0){													// fBbvXCb`|PnmĂ鎞
		delay_ms(20);											// 20mS Delay
		j = ((~PIND) & DIPSW_INIT);								// ]ăfBbvXCb`f[^擾
		if(j != 0){												// QxƂnmĂ鎞
			proc_init();										// iiv[vj
		}
	}

	j = ((~PIND) & DIPSW_COMM);									// ]ăfBbvXCb`f[^擾
	if(j != 0){													// fBbvXCb`|PnmĂ鎞
		delay_ms(20);											// 20mS Delay
		j = ((~PIND) & DIPSW_COMM);								// ]ăfBbvXCb`f[^擾
		if(j != 0){												// QxƂnmĂ鎞
			proc_comm();										// ʐMiiv[vj
		}
	}


	if(lcd_active == 1){										// kbcL̎
		disp_title();											// ^Cg\
		rtc_read();												// RTC N ǂݏo
		disp_ymd_hms();											// N\
		if(interval == 3){
			get_pgm_str(&str_month[0]);							// vÖ̕("MONTH")擾
		}else if(interval == 2){
			get_pgm_str(&str_hour[0]);							// vÖ̕("HOUR")擾
		}else if(interval == 1){
			get_pgm_str(&str_minute[0]);						// vÖ̕("MINUTE")擾
		}else{
			get_pgm_str(&str_non[0]);							// vÖ̕("NON")擾
		}
		disp_lcd(10, 1, disp_moji);								// display LCD(16char x 2Line) Down Side

#ifdef		PART_TIME_DISP
		close_lcd();											// Close LCD
#endif		//PART_TIME_DISP
	}

	twi_close();												// TWI gpI


#ifdef		PART_TIME_DISP
	EICRA &= ~((1 << ISC11) | (1 << ISC10));					// INT1 Low Level Interrupt
	EIMSK |= (1 << INT1);										// INT1 Interrupt Enable
#endif		//PART_TIME_DISP
	gReq_lcd_disp = 0;
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);						// X[vFp[_E[h
	j = 0;
	sei();															// 荞݉
	while(1){
		if(rtc_1h_flg != 0){										// qsbĂ鎞̂PԌoߗp
			twi_init();												// TWI ݒigpJnj
			rtc_inta_clear();										// RTC /INTA M̃NA
			led_on_off(1);											// LED ON
			rtc_1h_flg = 0;
			us = get_ondo_mizu();									// ݂̉xƐ̗L擾
			wpt = write_data(us);									// xƃZXf[^ɏ

#ifdef		PART_TIME_DISP
#else		//PART_TIME_DISP
			if(wpt != 0xffff){
				if(lcd_active == 1){								// kbcL̎
					if(j == 0){
						j = 1;
						get_pgm_str(&str_space10[0]);				// vÖ̕("          ")擾
						disp_lcd( 0, 1, &disp_moji[0]);				// display LCD(16char x 2Line) Down Side
						disp_lcd(10, 1, &disp_moji[4]);				// display LCD(16char x 2Line) Down Side
					}
					rtc_read();										// RTC N ǂݏo
					disp_md_hms();									// b\

					wtod_05u((char *)&disp_moji[0], wpt);

// Ver0.02			disp_lcd(4, 1, &disp_moji[1]);					// display LCD(16char x 2Line) Down Side
// Ver0.02			wtod_04x((char *)&disp_moji[0], us);
// Ver0.02			disp_lcd(10, 1, &disp_moji[0]);					// display LCD(16char x 2Line) Down Side
// Ver0.02			disp_lcd(14, 1, (unsigned char *)"H");			// display LCD(16char x 2Line) Down Side

					disp_lcd(1, 1, &disp_moji[1]);					// Ver0.02 display LCD(16char x 2Line) Down Side
					wtod_04x((char *)&disp_moji[0], us);			// Ver0.02
					disp_lcd( 6, 1, &disp_moji[0]);					// Ver0.02 display LCD(16char x 2Line) Down Side
					disp_lcd(10, 1, (unsigned char *)"H");			// Ver0.02 display LCD(16char x 2Line) Down Side
					wtod_5u((char *)disp_moji, gAd_mizu);			// Ver0.02 ZT@`^cl
					disp_lcd(12, 1, &disp_moji[1]);					// Ver0.02 \
				}
			}
#endif		//PART_TIME_DISP

#ifdef		PART_TIME_DISP
			rtc_read();												// RTC N ǂݏo
#endif		//PART_TIME_DISP
			led_on_off(0);											// LED OFF
			delay_ms(100);											// 100mS Delay
#ifdef		PART_TIME_DISP
			close_lcd();											// Close LCD
#endif		//PART_TIME_DISP
			twi_close();											// TWI gpI
			EIMSK |= (1 << INT0);									// INT0 Interrupt Enable
		}

		if(gReq_lcd_disp != 0){										// \vL
			twi_init();												// TWI ݒigpJnj
			led_on_off(1);											// LED ON
			init_lcd();												// kbcݒ
			gReq_lcd_disp = 0;

			disp_md_hms();											// b\
			if(wpt != 0xffff){
				wtod_05u((char *)&disp_moji[0], wpt);
			}else{
				get_pgm_str(&str_5minus[0]);						// vÖ̕("-----")擾
			}

// Ver0.02	disp_lcd(4, 1, &disp_moji[1]);							// display LCD(16char x 2Line) Down Side
// Ver0.02	wtod_04x((char *)&disp_moji[0], us);
// Ver0.02	disp_lcd(10, 1, &disp_moji[0]);							// display LCD(16char x 2Line) Down Side
// Ver0.02	disp_lcd(14, 1, (unsigned char *)"H");					// display LCD(16char x 2Line) Down Side

			disp_lcd( 1, 1, &disp_moji[1]);							// Ver0.02 display LCD(16char x 2Line) Down Side
			wtod_04x((char *)&disp_moji[0], us);					// Ver0.02
			disp_lcd( 6, 1, &disp_moji[0]);							// Ver0.02 display LCD(16char x 2Line) Down Side
			disp_lcd(10, 1, (unsigned char *)"H");					// Ver0.02 display LCD(16char x 2Line) Down Side
			wtod_5u((char *)disp_moji, gAd_mizu);					// Ver0.02 ZT@`^cl
			disp_lcd(12, 1, &disp_moji[1]);							// Ver0.02 \

			led_on_off(0);											// LED OFF

			twi_close();											// TWI gpI

			wait_sw_off();											// XCb`@܂ŉiv[v
			EIMSK |= (1 << INT1);									// INT1 Interrupt Enable
		}

		sleep_mode();												// X[vڍs
	}
}
