/************************************/
// AVR ATmega328 Temperature Program
// ԉxƒlۑvO
/*   One Wire Program for ATmega328	*/
/*  for 18B20 etc.					*/
//
// File Name:one_wire.c
//
/*  2012/11/12 NEW Taishi	TAB4		*/
/************************************/
#include	<avr/io.h>

#include	"ATmega328_ONDO2.h"
#include 	"timer.h"

#include 	"One_wire.h"

#define		TIME_CHK									// Ԃv鎞ɐA{̓RgAEg
// Wlg͊mFĂȂ

volatile unsigned char	wait_1us;

//***********************************
//@TOOr҂					*
//***********************************
static
void	delay_500us(void)
{
	unsigned short	i;

#ifdef	MHz_1
	// CPU Clock:1MHz
	for(i = 0; i < 45; i++){
		wait_1us++;
	}
#else	//MHz_1
	// CPU Clock:8MHz
	for(i = 0; i < 360; i++){
		wait_1us++;
	}
#endif	//MHz_1
}
//***********************************
//@SROr҂					*
//***********************************
static
void	delay_430us(void)
{
	unsigned short	i;

#ifdef	MHz_1
	// CPU Clock:1MHz
	for(i = 0; i < 39; i++){
		wait_1us++;
	}
#else	//MHz_1
	// CPU Clock:8MHz
	for(i = 0; i < 360; i++){
		wait_1us++;
	}
#endif	//MHz_1
}
//***********************************
//@PQOr҂					*
//***********************************
static
void	delay_120us(void)
{
	unsigned char	i;

#ifdef	MHz_1
	// CPU Clock:1MHz
	for(i = 0; i < 14; i++){
		wait_1us++;
	}
#else	//MHz_1
	// CPU Clock:8MHz
	for(i = 0; i < 112; i++){
		wait_1us++;
	}
#endif	//MHz_1

}
//***********************************
//@POSr҂					*
//***********************************
static
void	delay_104us(void)
{
	unsigned char	i;

#ifdef	MHz_1
	// CPU Clock:1MHz
	for(i = 0; i < 12; i++){
		wait_1us++;
	}
#else	//MHz_1
	// CPU Clock:8MHz
	for(i = 0; i < 96; i++){
		wait_1us++;
	}
#endif	//MHz_1

}
//***********************************
//@VUr҂					*
//***********************************
static
void	delay_76us(void)
{
	unsigned char	i;

#ifdef	MHz_1
	// CPU Clock:1MHz
	for(i = 0; i < 8; i++){
		wait_1us++;
	}
#else	//MHz_1
	// CPU Clock:8MHz
	for(i = 0; i < 64; i++){
		wait_1us++;
	}
#endif	//MHz_1

}
//***********************************
//@PTr҂					*
//***********************************
static
void	delay_15us(void)
{

#ifdef	MHz_1
	wait_1us++;
	wait_1us++;
#else	//MHz_1
	unsigned char	i;
	for(i = 0; i < 7; i++){
		wait_1us++;
	}
#endif	//MHz_1

}
//***********************************
//@Pr҂					*
//***********************************
#ifdef	MHz_1
#define	delay_1us()		wait_1us++					// Pr҂
#else	//MHz_1
static
void	delay_1us(void)
{
	delay_2us(1);									// Qr҂
}
#endif	//MHz_1

/************************************/
/* One Wire Reset					*/
/*  Return     0 : Reset Done 		*/
/*  Return NOT 0 : Can't Reset		*/
/* 2008/ 2/14  Taishi NEW				*/
/************************************/
unsigned int	one_wire_reset(void)
{
	unsigned int	r;

	PORTD &= ~(1 << PD7);						// PD7='L' o͂kɂĂ
	DDRD |= (1 << DDD7);						// PD7:Output@|[g̐ݒo͂ɂ

#ifdef		TIME_CHK																			// Ԃv
	PORTC |= (1 << PC3);																		// PC3='H' `FbNp
#endif		//TIME_CHK

	delay_500us();								// fkfŒSWOro͂
	DDRD &= ~(1 << DDD7);						// PD7:Input --> Hiz(Pullup 'H')@|[g̐ݒ͂ɂ

#ifdef		TIME_CHK																			// Ԃv
	PORTC &= ~(1 << PC3);																		// PC3='L' `FbNp
	PORTC |= (1 << PC3);																		// PC3='H' `FbNp
#endif		//TIME_CHK

	delay_76us();
	r = (unsigned int)(PIND & (1 << PIND7));	// f[^ǂݎiłcrPWaQOL΁fkf̂͂j
#ifdef		TIME_CHK																			// Ԃv
	PORTC &= ~(1 << PC3);																		// PC3='L' `FbNp
	PORTC |= (1 << PC3);																		// PC3='H' `FbNp
#endif		//TIME_CHK

	delay_430us();								// fgfɂĂŒSWOr͑҂

#ifdef		TIME_CHK																			// Ԃv
	PORTC &= ~(1 << PC3);																		// PC3='L' `FbNp
#endif		//TIME_CHK

	return(r);
}

/********************************/
/* One Wire Read 1Bit			*/
/*  Return     0 : Input='L' 	*/
/*  Return NOT 0 : Input='H'	*/
/* 2008/ 2/14  Taishi NEW			*/
/********************************/
unsigned int	one_wire_read_bit(void)
{
	unsigned int	r;

	PORTD &= ~(1 << PD7);			// PD7='L'
	DDRD |= (1 << DDD7);			// PD7:Output --> 'L'
	delay_1us();

#ifdef		TIME_CHK																			// Ԃv
	PORTC |= (1 << PC2);																		// PC2='H' `FbNp
#endif		//TIME_CHK

	DDRD &= ~(1 << DDD7);			// PD7:Input --> Hiz(Pullup 'H')
	delay_15us();
	r = (unsigned int)(PIND & (1 << PIND7));

#ifdef		TIME_CHK																			// Ԃv
	PORTC &= ~(1 << PC2);																		// PC2='L' `FbNp
#endif		//TIME_CHK

	return(r);
}

/********************************/
/* One Wire Write 1Bit			*/
/*  Arg. bit   0 : Output='L' 	*/
/*         NOT 0 : Output=Hiz	*/
/* 2008/ 2/14  Taishi NEW			*/
/********************************/
void	one_wire_write_bit(unsigned char bit)
{

	PORTD &= ~(1 << PD7);			// PD7='L'
	DDRD |= (1 << DDD7);			// PD7:Output --> 'L'
	delay_1us();

#ifdef		TIME_CHK																			// Ԃv
	PORTC |= (1 << PC1);																		// PC1='H' `FbNp
#endif		//TIME_CHK

	if(bit != 0){
		DDRD &= ~(1 << DDD7);		// PD7:Input --> Hiz(Pullup 'H')
	}
	delay_104us();
	DDRD &= ~(1 << DDD7);		// PD7:Input --> Hiz(Pullup 'H')

#ifdef		TIME_CHK																			// Ԃv
	PORTC &= ~(1 << PC1);																		// PC1='L' `FbNp
#endif		//TIME_CHK

}


/********************************/
/* One Wire Read 1Byte			*/
/*  Return     Read Valu	 	*/
/* 2008/ 2/14  Taishi NEW			*/
/********************************/
unsigned char	one_wire_read_byte(void)
{
	int				i;
	unsigned char	bit;
	unsigned char	r;

	r = 0;
	for(i=0,bit=0x01;i < 8;i++,bit <<= 1){
		if(one_wire_read_bit() != 0){
			r |= bit;
		}
		delay_120us();
	}

	return(r);
}

/********************************/
/* One Wire Write 1Byte			*/
/*  Arg.     Write Valu	 		*/
/* 2008/ 2/14  Taishi NEW			*/
/********************************/
void	one_wire_write_byte(unsigned char uc)
{
	int				i;
	unsigned char	bit;

	for(i=0,bit=0x01;i < 8;i++,bit <<= 1){
		one_wire_write_bit(uc & bit);
	}

	delay_104us();
}

/********************************/
/* One Wire Port(Bit) Initial	*/
/* 2008/ 4/4   Taishi NEW			*/
/********************************/
void	one_wire_initial(void)
{
	PORTD &= ~(1 << PD7);			// PD7='L'
	DDRD &= ~(1 << DDD7);			// PD7:Input
}
