//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAIV[^(8MHz)ɂj
// ԉxƒlۑvO
// File Name:Rtc_Rx8025.c
//
//  PC5(SCL): TWI-SCL
//  PC4(SDA): TWI-SDA
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2012/11/12 Taishi New
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<compat/twi.h>
#include	<avr/pgmspace.h>

#include	"ATmega328_ONDO2.h"
#include	"Mega_Twi.h"
#include	"utl.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"glb_dat.h"

#include	"Rtc_Rx8025.h"


volatile unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
volatile unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
volatile unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
volatile unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
volatile unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
volatile unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
volatile unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
volatile unsigned char	gRTC_control1;			// qsb Rg[P̃f[^
volatile unsigned char	gRTC_control2;			// qsb Rg[Q̃f[^
volatile unsigned char	gRTC_control1_first;	// qsb Nŏ̃Rg[P̃f[^
volatile unsigned char	gRTC_control2_first;	// qsb Nŏ̃Rg[Q̃f[^
volatile unsigned char	gRTC_reg[16];			// SẴWX^̒l

volatile unsigned char	rtc_1h_flg;				// qsbĂ鎞̂PԌoߗp
volatile unsigned short	interval;				// Ԋui݊Ԋuj@OFo͂ȂAPFƁAQFƁARF
//*****************************************
// qsbG[
//*****************************************
void	rtc_error(void)
{
#ifdef	_SIMURATION_					// V~[V̎
		;
#else	//_SIMURATION_
	// kdc𑬂_ł
	for(;;){
		led_on_off(1);					// LED ON
		delay_ms(100);					// 100mS Delay
		led_on_off(0);					// LED OFF
		delay_ms(100);					// 100mS Delay
	}
#endif	//_SIMURATION_
}

//***************************
// RTC Initial
//  qsb̏ݒ
//***************************
unsigned char	rtc_init(void)
{
	unsigned char	r = 0;
	unsigned char	t1;
	unsigned char	t2;
	unsigned char	req_init=0;

	twi_init();


	// Pbo͐ݒ
//  PD2(INT0): Pulse In from RTC Square Wave Signal(1Hz,4kHz,8kHz,32kHz)
	DDRD &= ~(1 << DDD2);					// Port-D Bit2 : Intput


	r = rtc_control_read();					// RTC Rg[f[^ǂݏo
	if(r != 0){
		return(r);
	}

	t1 = gRTC_control1;						// ǂݏoRg[f[^ꎞޔ
	t2 = gRTC_control2;						// ǂݏoRg[f[^ꎞޔ
	gRTC_control1 &= ~(RTC_CONTROL1_CT2 | RTC_CONTROL1_CT1 | RTC_CONTROL1_CT0);		// { 12/24:1(24H), CT2:1 & CT1:1(j

	if(interval == 3){						// RF(POOOOOOb̎j
		gRTC_control1 |= (RTC_CONTROL1_1224 | RTC_CONTROL1_CT2 | RTC_CONTROL1_CT1 | RTC_CONTROL1_CT0);		// { 12/24:1(24H), CT2:1 & CT1:1(j
	}else if(interval == 2){				// QF(OOOOb̎j
		gRTC_control1 |= (RTC_CONTROL1_1224 | RTC_CONTROL1_CT2 | RTC_CONTROL1_CT1);		// `FbNp 12/24:1(24H), CT2:1 & CT0:1(j
	}else if(interval == 1){				// PF(OOb̎j
		gRTC_control1 |= (RTC_CONTROL1_1224 | RTC_CONTROL1_CT2 | RTC_CONTROL1_CT0);		// `FbNp 12/24:1(24H), CT2:1 & CT0:1(j
	}else{									// OFo͂Ȃ
		;
	}


	gRTC_control2 &= ~(RTC_CONTROL2_VDSL | RTC_CONTROL2_VDET | RTC_CONTROL2_PON | RTC_CONTROL2_CTFG | RTC_CONTROL2_WAFG | RTC_CONTROL2_DAFG);					// { 
	gRTC_control2 |=  (RTC_CONTROL2_XST);											// { 

	r = rtc_control_write();				// RTC Rg[f[^
	gRTC_control1_first = t1;				// Nŏ̃Rg[Pf[^
	gRTC_control2_first = t2;				// Nŏ̃Rg[Qf[^
	if(r != 0){
		return(r);
	}

	if((t2 & RTC_CONTROL2_PON) == RTC_CONTROL2_PON){								// d
		req_init=1;
	}else if((t2 & RTC_CONTROL2_XST) == 0){											// U~
		req_init=1;
	}

	if(req_init == 1){
		gRTC_sec  = 0x00;						// qsb b̃f[^ (BCD 0--59)
		gRTC_min  = 0x59;						// qsb ̃f[^ (BCD 0--59)
		gRTC_hou  = 0x23;						// qsb ̃f[^ (BCD 0--23j
		gRTC_wday = 0x07;						// qsb j̃f[^ (BCD 1--7)
		gRTC_day  = 0x31;						// qsb ̃f[^ (BCD 1--31)
		gRTC_mon  = 0x12;						// qsb ̃f[^ (BCD 1--12j
		gRTC_year = 0x12;						// qsb Ñf[^ (BCD 0--99)
		rtc_write();							// RTC N 
	}

	// INT0 Interrupt Initial
	rtc_1h_flg = 0;								// qsbĂ鎞̂PԌoߗp
	EICRA &= ~((1 << ISC01) | (1 << ISC00));	// INT0 Low Level Interrupt
	EIMSK |= (1 << INT0);						// INT0 Interrupt Enable

	return(0);
}

//***************************
// RTC ǂݏof[^NA
//***************************
void	rtc_read_data_clear(void)
{
	gRTC_sec = 0;						// qsb b̃f[^ (BCD 0--59)
	gRTC_min = 0;						// qsb ̃f[^ (BCD 0--59)
	gRTC_hou = 0;						// qsb ̃f[^ (BCD 0--23j
	gRTC_wday = 1;						// qsb j̃f[^ (BCD 1--7)
	gRTC_day = 1;						// qsb ̃f[^ (BCD 1--31)
	gRTC_mon = 1;						// qsb ̃f[^ (BCD 1--12j
	gRTC_year = 0;						// qsb Ñf[^ (BCD 0--99)
}

//***************************
// RTC N ǂݏo
//  ǂݏof[^͈ȉ̕ϐɓ
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
//***************************
unsigned char rtc_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	r = twi_write(0x00);							// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	twi_stop();


	r = twi_start(RX8025_ID,RX8025_ADDR,TW_READ);	// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhXbj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_sec = data;								// qsb b̃f[^ (BCD 0--59)

	r = twi_read(&data,ACK);						// TWI ǂݏoiQԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_min = data;								// qsb ̃f[^ (BCD 0--59)

	r = twi_read(&data,ACK);						// TWI ǂݏoiRԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_hou = data;								// qsb ̃f[^ (BCD 0--23j

	r = twi_read(&data,ACK);						// TWI ǂݏoiSԖڂ̃AhXjj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_wday = data;								// qsb j̃f[^ (BCD 1--7)

	r = twi_read(&data,ACK);						// TWI ǂݏoiTԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_day = data;								// qsb ̃f[^ (BCD 1--31)

	r = twi_read(&data,ACK);						// TWI ǂݏoiUԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_mon = data;								// qsb ̃f[^ (BCD 1--12j

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0 iVԖڂ̃AhXNj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		rtc_read_data_clear();						// RTC ǂݏof[^NA
		return(r);
	}
	gRTC_year = data;								// qsb Ñf[^ (BCD 0--99)

	twi_stop();

	return(r);
}

//***************************
// RTC N 
//  ݃f[^͈ȉ̕ϐɓĂ镨Ƃ
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
//***************************
unsigned char	rtc_write(void)
{
	unsigned char	r;

	gRTC_sec &= 0x7F;
	r=twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r=twi_write(0x00);								// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_sec);							// b̃f[^ (BCD 0--59)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_min);							// ̃f[^ (BCD 0--59)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_hou);							// ̃f[^ (BCD 0--23j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_wday);							// j̃f[^ (BCD 1--7)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_day);							// ̃f[^ (BCD 1--31)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_mon);							// ̃f[^ (BCD 1--12j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	r=twi_write(gRTC_year);							// Ñf[^ (BCD 0--99)
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC Rg[f[^ǂݏo
//  ǂݏof[^ gRTC_control1 & gRTC_control2 ɓ
//
//	RX8025_ID		0x60	// I2C RX8025 Device Identifier
//	RX8025_ADDR		0x04	// I2C RX8025 Device Address
//  TW_READ			1
//  TW_WRITE		0
//
//***************************
unsigned char	rtc_control_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL1_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_READ);	// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}
	r = twi_read(&data,ACK);						// TWI ǂݏoiUԖڂ̃AhXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_control1 = data;							// qsb Rg[P̃f[^

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_control2 = data;							// qsb Rg[Q̃f[^

	twi_stop();

	return(0);
}
//***************************
// RTC Rg[f[^
//  ݃f[^ unsigned char gRTC_control1 & gRTC_control2 ɓĂ镨Ƃ
//***************************
unsigned char	rtc_control_write(void)
{
	unsigned char	r;

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL1_ADDR);				// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(gRTC_control1);					// Rg[Pf[^
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(gRTC_control2);					// Rg[Qf[^
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(r);
}

//***************************
// RTC SẴWX^f[^ǂݏo
//  ǂݏof[^ gRTC_reg[16] ɓ
//
//	RX8025_ID		0x60	// I2C RX8025 Device Identifier
//	RX8025_ADDR		0x04	// I2C RX8025 Device Address
//  TW_READ			1
//  TW_WRITE		0
//
//***************************
unsigned char	rtc_all_register_read(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(0x00);							// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_READ);	// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOOj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[0] = data;								// qsb ŏ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOPj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[1] = data;								// qsb QԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOQj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[2] = data;								// qsb RԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OORj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[3] = data;								// qsb SԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOSj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[4] = data;								// qsb TԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOTj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[5] = data;								// qsb UԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOUj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[6] = data;								// qsb VԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOVj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[7] = data;								// qsb WԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOWj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[8] = data;								// qsb XԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOXj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[9] = data;								// qsb POԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OO`j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[10] = data;							// qsb PPԖڂ̃AhX̃f[^

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOaj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[11] = data;							// qsb PQԖڂ̃AhX̃f[^

	r = twi_read(&data,NACK);						// TWI ǂݏoiŏ̃AhX@OObj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[12] = data;							// qsb PRԖڂ̃AhX̃f[^

	twi_stop();


	gRTC_reg[13] = 0x00;							// qsb PSԖڂ̃AhX̃f[^̓ANZX֎~Ȃ̂łOi[j	


	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(0xe0);							// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_READ);	// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,ACK);						// TWI ǂݏoiŏ̃AhX@OOOj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[14] = data;							// qsb PTԖڂ̃AhX̃f[^

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}
	gRTC_reg[15] = data;							// qsb PUԖڂ̃AhX̃f[^

	twi_stop();


	return(0);
}

//***************************
// RTC /INTA M̃NA
//  Control2  CTFG rbgOɂ
//
//	RX8025_ID		0x60	// I2C RX8025 Device Identifier
//	RX8025_ADDR		0x04	// I2C RX8025 Device Address
//  TW_READ			1
//  TW_WRITE		0
//
//***************************
unsigned char	rtc_inta_clear(void)
{
	unsigned char	data;
	unsigned char	r;


	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL2_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_READ);	// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}

	twi_stop();


	data &= ~RTC_CONTROL2_CTFG;						// qsb Rg[Q̂bsefrbgNA


	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL2_ADDR);				// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(data);							// Rg[Qf[^݁ibsefrbgNAς݂̕j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(0);
}
//***************************
// RTC /INTA /INTBM̃NA
//  Control2  CTFG,WAFG,DAFG rbgOɂ
//
//	RX8025_ID		0x60	// I2C RX8025 Device Identifier
//	RX8025_ADDR		0x04	// I2C RX8025 Device Address
//  TW_READ			1
//  TW_WRITE		0
//
//***************************
unsigned char	rtc_inta_intb_clear(void)
{
	unsigned char	data;
	unsigned char	r;

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL2_ADDR);				// TWI  iǏoJnAhXށj
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(RX8025_ID,RX8025_ADDR,TW_READ);	// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_READ;
		return(r);
	}

	r = twi_read(&data,NACK);						// TWI ǂݏo Ō NACK=0
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_READ;
		return(r);
	}

	twi_stop();

	data &= ~(RTC_CONTROL2_CTFG | RTC_CONTROL2_WAFG | RTC_CONTROL2_DAFG);	// qsb Rg[Q̂bsefAv`efAc`efrbgNA


	r = twi_start(RX8025_ID,RX8025_ADDR,TW_WRITE);	// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(RTC_CONTROL2_ADDR);				// TWI  AhX
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(data);							// Rg[Qf[^݁ibsefrbgNAς݂̕j
	if(r != 0){										// G[̎
		r = RTC_ERR_TWI_WRITE;
		return(r);
	}

	twi_stop();

	return(0);
}
/************************************************/
/* C^[oo͊Ԋu̐ݒ					*/
/*  							*/
/*@@@@OFo͖							*/
/*@@@@PF(OOb̎j				*/
/*@@@@QF(OOOOb̎j		*/
/*@@@@RF(POOOOOOb̎j	*/
/*@݂̓ύX邾ŁAۑ͂Ȃ̂	*/
/*@@@N͕ۑݒ̓ɂȂB	*/
/************************************************/
unsigned char	rtc_set_interval(unsigned char intval)
{
	unsigned char	r;

	r = rtc_control_read();							// RTC Rg[f[^ǂݏo
													//  ǂݏof[^ gRTC_control1 & gRTC_control2 ɓ
	if(r != 0){
		return(r);
	}

	gRTC_control1 &= ~(RTC_CONTROL1_CT2 | RTC_CONTROL1_CT1 | RTC_CONTROL1_CT0);		// CT2:0, CT1:0 & CT0:0(o͖j

	if(intval == 3){																// RF
		gRTC_control1 |= (RTC_CONTROL1_CT2 | RTC_CONTROL1_CT1 | RTC_CONTROL1_CT0);
	}else if(intval == 2){															// QF
		gRTC_control1 |= (RTC_CONTROL1_CT2 | RTC_CONTROL1_CT1);
	}else if(intval == 1){															// PF	
		gRTC_control1 |= (RTC_CONTROL1_CT2 | RTC_CONTROL1_CT0);
	}else{																			// OFo͂Ȃ
		;
	}

	r = rtc_control_write();						// RTC Rg[f[^

	return(r);
}
//*****************************************
// INT0 Interrupt
//  Start Bit Falling Edge Sence
// 	qsb@hms`M
//  \߁@qsb̏ݒłPԖo͂ɐݒ肷邱
//  ̒łqsbɃANZXĊݐM߂Ƃ
//@@Qij̏Ŗ߂ĂȂȂ̂ŁA
//@@ł́@O荞݂sɂ邾ŁACŊݐM𗎂ƂB
//@@RQWŏL̂悤ɂȂBiPUWł̗͂lȎ͖j
//*****************************************
ISR (INT0_vect)
{
	rtc_1h_flg++;								// qsbĂ鎞̂PԌoߗp

	EIMSK &= ~(1 << INT0);						// INT0 Interrupt Disable

}
