//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:Save_Dt.c
//
//  2012/11/19 Taishi  New (TAB4)
//*****************************************
#include	<avr/io.h>
#include	<avr/pgmspace.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"glb_dat.h"
#include	"lcd.h"
#include	"Seeprom.h"
#include	"utl.h"
#include	"Rtc_Rx8025.h"
#include	"display.h"

#include	"Save_Dt.h"

/* EEPROM̌܂AhXïׂRj */
#define		E_PTR1			0x0010		/* xf[^|C^ */
#define		E_PTR2			0x0012		/* xf[^|C^ */
#define		E_PTR3			0x0014		/* xf[^|C^ */
#define		E_PTR4			0x0016		/* xf[^|C^ */
#define		E_MEM			0x0060		/* f[^ */
#define		E_STR			0x0080		/* Jnf[^ */

#define		E_ONDODATA		0x0100		/* xf[^̂͂ */

static	unsigned short	data[4];			// S[hď̃f[^鏊


/****************************************/
/* wAhXPoCg̓ǂݏo	*/
/*  adr:ǂݏoEEPROM̃AhX	*/
/* ߂l@ǂݏof[^				*/
/****************************************/
unsigned char	e2_read_byte(unsigned short adr)
{
	unsigned char	r;

	seep1025_read_1(adr, (void *)&r);

	return(r);
}
/****************************************************/
/* wAhXwoCg̓ǂݏo			*/
/*  adr:ǂݏoEEPROM̃gbvAhX		*/
/*       uc:ǂݏof[^鏊				*/
/*        n:ǂݏof[^						*/
/* ߂l@Ȃ										*/
/****************************************************/
void	rd_pron_nbyte(unsigned short adr,unsigned char *uc,int n)
{
	int				i;

	for(i=0;i<n;i++,adr++,uc++){
		seep1025_read_1(adr, (void *)uc);
	}
}
/****************************************************/
/* wAhXw胏[h̓ǂݏo			*/
/*  adr:ǂݏoEEPROM̃gbvAhX		*/
/*       ud:ǂݏof[^鏊				*/
/*        n:ǂݏof[^						*/
/* ߂l@Ȃ										*/
/****************************************************/
void	rd_pron_nword(unsigned short adr,unsigned short *ud,int n)
{
	int				i;

	for(i=0;i<n;i++,adr++,ud++){
		seep1025_read_2(adr, (void *)ud);
	}
}
/****************************************/
/* wAhX 1[h̏	*/
/*  adr:EEPROM̃AhX	*/
/*       ud:ރf[^				*/
/* ߂l@Ȃ							*/
/*  wAhX͋Ɍ			*/
/*  iy[WCgĝŁj			*/
/****************************************/
void	wr_pron_nword(unsigned short adr,unsigned short *ud)
{
	seep1025_write_2(adr, (void *)ud);		// Seeprom QoCgf[^̏
}

/****************************************/
/* EEPROM̃f[^݃|C^	*/
/*  da:|C^[̒l				*/
/****************************************/
void	e2_ptdata_wr(unsigned short da)
{
	data[0] = da;
	data[1] = da;
	data[2] = da;
	data[3] = da;

	seep1025_write_8(E_PTR1, (void *)data);	// Seeprom WoCgf[^̏
}
/****************************************/
/* EEPROM̃f[^݃|C^ǂ	*/
/*  Ȃ							*/
/* ߂l@|C^[̒l				*/
/****************************************/
unsigned short	e2_ptdata_rd(void)
{
	unsigned short	r;

	seep1025_read_8(E_PTR1, (void *)data);	// Seeprom WoCgf[^̓ǂݏo
	r = tasuuketu_ui(data[0], data[1], data[2], 0xffff);
	return(r);
}
/****************************************/
/* EEPROM̉xf[^			*/
/*  adr:EEPROM̃AhX	*/
/*       ud:ރf[^				*/
/* ߂l@Ȃ							*/
/****************************************/
void	e2_ondo_wr(unsigned short adr,unsigned short ud)
{
	data[0] = ud;
	data[1] = ud;
	data[2] = ud;
	data[3] = ud;

	seep1025_write_8(adr, (void *)data);	// Seeprom WoCgf[^̏
}
/************************************/
/* f[^ǂŒǉ		*/
/************************************/
void	e2_add_mem(unsigned char *buf)
{
	char			bf[18];
	int				i;
	unsigned char	cd;

	for(i=0;i<16;i++){
		cd = 0;
		seep1025_read_1((unsigned long)(E_MEM+i), &cd);	// Seeprom PoCgf[^̓ǂݏo
		if ((cd < ' ')||(cd > '~')){
			cd = '.';
		}
		bf[i]= (char)cd;
	}
	bf[16]=0;
	lstrcat((char *)buf,bf);
}
/********************************/
/* f[^(16byte)		*/
/********************************/
void	e2_set_mem(unsigned char *buf)
{
	seep1025_write_8(E_MEM, (void *)buf);	// Seeprom WoCgf[^̏
	seep1025_write_8(E_MEM+8, (void *)(buf+8));	// Seeprom WoCgf[^̏
}
/********************************/
/* X^[g(16byte)	*/
/********************************/
void	e2_set_start_string(unsigned char *buf)
{
	seep1025_write_8(E_STR, (void *)buf);	// Seeprom WoCgf[^̏
	seep1025_write_8(E_STR+8, (void *)(buf+8));	// Seeprom WoCgf[^̏
}
/********************************/
/* X^[gǂ(16byte)	*/
/********************************/
void	e2_get_start_string(unsigned char *buf)
{
	unsigned char	bf[18];

	seep1025_read_8(E_STR, (void *)bf);	// Seeprom WoCgf[^̓ǂݏo
	seep1025_read_8(E_STR+8, (void *)(bf+8));	// Seeprom WoCgf[^̓ǂݏo
	bf[16]=0;
	lstrcat((char *)buf,(char *)bf);

}
/****************************************/
/* xf[^ރAhX߂	*/
/*  pt:ރ|C^[l			*/
/* ߂l@EEPROM ̃AhX			*/
/****************************************/
unsigned short	get_ondodata_adr(unsigned short pt)
{
	unsigned short	r;

	r = (unsigned short)(pt * 8 + E_ONDODATA);

	return(r);
}
//*****************************************
/* N𕶎ɕϊ */
//  Nb̃f[^͉LɗL
//	unsigned char	gRTC_min;		qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;		qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_day;		qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_date;		qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;		qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;		qsb Ñf[^ (BCD 0--99)
//*****************************************
static
void	add_conv_min_year_to_asc(char *bf)
{
	wtod_02x(bf,gRTC_year);	// N
	bf += 2;
	wtod_02x(bf,gRTC_mon);		// 
	bf += 2;
	wtod_02x(bf,gRTC_day);		// 
	bf += 2;
	wtod_02x(bf,gRTC_hou);		// 
	bf += 2;
	wtod_02x(bf,gRTC_min);		// 

}

//*****************************************
// xƃZXf[^ɏ
//  ߂l@iȂ͂Oj
//*****************************************
unsigned short	write_data(unsigned short us)
{
	unsigned short	pt;
	unsigned short	adr;

	pt=e2_ptdata_rd();											// EEPROM̃f[^݃|C^ǂݏo
	if (pt < (24 * 30 * 6)){									// T̃f[^܂ŃZ[u
		if(pt == 0){											// @ŏ̎
			rtc_read();											// RTC N ǂݏo
			get_pgm_str(&str_str20[0]);							// vÖ̕("STR:20")擾
			add_conv_min_year_to_asc((char *)(&disp_moji[6]));	// ɕϊ
			e2_set_start_string(&disp_moji[0]);					// EEPROMɃX^[g
		}

		adr = get_ondodata_adr(pt);								// xf[^ރAhX߂
		e2_ondo_wr(adr,us);										// EEPROM̉xf[^
		e2_ptdata_wr(pt+1);										// EEPROM̎̃f[^݃|C^
	}else{
		pt = 0xffff;
	}
	return(pt);
}

//*****************************************
// xƃZXf[^ǂ
//*****************************************
unsigned short	read_data(unsigned short num)
{
	unsigned short	r=0;
// ܂oĂȂ

	return(r);
}
