//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// File Name:Seep_1025.c
// ԉxƒlۑvO
//   iq[Yf[^@is`fgpȂAAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmƕj
//
//@Serial EEPROM 24FC1025 z肵Ă
//
//  2012/08/06 New  Taishi(Ver 1.20) 
//*****************************************
#include		<avr/io.h>
#include		<compat/twi.h>

#include		"ATmega328_ONDO2.h"

#if		SEEPROM_IC == 1025		// Serial EEPROM:Microchip 24FC1025
								//  (Microchip 24FC1025 ȊO̎́AM24FC1025_ADDR  M24FC1025_BLOCK ς邩Ȃj

#include		"Mega_Twi.h"
#include		"Timer.h"
#include		"utl.h"
#include		"LCD.h"
#include		"port_bit.h"
#include		"glb_dat.h"

#include		"Seeprom.h"

#define M24FC1025_ID		0xA0	// SEEPROM Microchip 24FC1025 Device IdentifieriʂSrbgj
#define M24FC1025_ADDR		0x06	// A2:H, A1:H, A0:H  A2  Device Address ɖ֌W(A2:L, A1:H, A0:H)iʂSrbg̓̏RrbgAcP`cRj
#define M24FC1025_BLOCK		0x08	// ʂUSoCg̎@foCXAhXɕtrbg

//***************************
// Seeprom Initial
// VAddoqnl̏ݒ
//***************************
void	seep1025_init(void)
{
		twi_init();
}

//***************************
// Seeprom PoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊
//  ߂l  0: ɏI
//          1:ُŏI
//  M24FC1025_ID		0xA0
//  M24FC1025_ADDR		0x06
//  TW_READ				1
//  TW_WRITE			0
//***************************
unsigned char	seep1025_read_1(unsigned long seep_addr, unsigned char *seep_data)
{
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	device_adr;
	unsigned char	r;

	twi_init();
	seep_addr &= 0x1ffff;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾Ȃ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	r = twi_start(M24FC1025_ID, device_adr, TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(data_adr_1st);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(data_adr_2nd);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(M24FC1025_ID, device_adr, TW_READ);			// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_START_TW_READ;
		return(r);
	}
	r = twi_read(seep_data, NACK);								// TWI ǂݏo
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_READ;
		return(r);
	}
	twi_stop();

	return(r);
}

//***************************
// Seeprom QoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊iQoCgj
//  ߂l Ȃ
//***************************
void	seep1025_read_2(unsigned long seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	device_adr;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x1fffe;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾Ȃ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	twi_start(M24FC1025_ID, device_adr, TW_WRITE);				// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX
	twi_stop();

	twi_start(M24FC1025_ID, device_adr, TW_READ);				// TWI Jn foCXhcƃfoCXAhXƂqd`c
	twi_read(seep_data+0, ACK);									// TWI ǂݏo
	twi_read(seep_data+1, NACK);								// TWI ǂݏo
	twi_stop();

}
//***************************
// Seeprom WoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊iWoCgj
//  ߂l Ȃ
//***************************
void	seep1025_read_8(unsigned long seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	device_adr;
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x1ffff;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾Ȃ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	twi_start(M24FC1025_ID, device_adr, TW_WRITE);				// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX
	twi_stop();

	twi_start(M24FC1025_ID, device_adr, TW_READ);				// TWI Jn foCXhcƃfoCXAhXƂqd`c
	for(i=0;i<7;i++){
		twi_read(seep_data+i, ACK);								// TWI ǂݏo
	}
	twi_read(seep_data+7, NACK);								// TWI ǂݏo
	twi_stop();

}

//***************************
// Seeprom USoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊iUSoCgj
//  ߂l Ȃ
//***************************
void	seep1025_read_64(unsigned long seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	device_adr;
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x1ffff;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾Ȃ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	twi_start(M24FC1025_ID, device_adr, TW_WRITE);				// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX
	twi_stop();

	twi_start(M24FC1025_ID, device_adr, TW_READ);				// TWI Jn foCXhcƃfoCXAhXƂqd`c
	for(i=0;i<63;i++){
		twi_read(seep_data+i, ACK);								// TWI ǂݏo
	}
	twi_read(seep_data+63, NACK);								// TWI ǂݏo
	twi_stop();

}

//***************************
// Seeprom PoCgf[^̏
//   seep_addr: VAddoqnl̃AhX
//   seep_data: VAddoqnl̏ރf[^
//  ߂l  0: ɏI
//          1:ُŏI
//***************************
unsigned char	seep1025_write_1(unsigned long seep_addr, unsigned char *seep_data)
{

	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	device_adr;
	unsigned char	r;

	twi_init();
	seep_addr &= 0x1ffff;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾Ȃ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	r = twi_start(M24FC1025_ID, device_adr, TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(data_adr_1st);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(data_adr_2nd);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(*seep_data);									// TWI  f[^
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	delay_ms(10);												// Wait 10mS

	return(r);
}

//***************************
// Seeprom QoCgf[^̏
//   seep_addr: VAddoqnl̃AhXiQoCg؂APrbgOj
//   seep_data: VAddoqnl̏ރf[^̗L鏊iQoCgj
//  ߂l Ȃ
//***************************
void	seep1025_write_2(unsigned long seep_addr, void *vseep_data)
{

	unsigned char	*seep_data;
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	device_adr;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x1fffe;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾ȂBQoCgŋ؂AhXɂ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	twi_start(M24FC1025_ID, device_adr, TW_WRITE);				// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX

	twi_write(*seep_data);										// TWI  f[^
	seep_data++;
	twi_write(*seep_data);										// TWI  f[^

	twi_stop();

	delay_ms(10);												// Wait 10mS
}
//***************************
// Seeprom WoCgf[^̏
//   seep_addr: VAddoqnl̃AhXiWoCg؂ARrbgOj
//   seep_data: VAddoqnl̏ރf[^̗L鏊iWoCgj
//  ߂l Ȃ
//***************************
void	seep1025_write_8(unsigned long seep_addr, void *vseep_data)
{

	unsigned char	*seep_data;
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	device_adr;
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x1fff8;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾ȂBWoCgŋ؂AhXɂ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	twi_start(M24FC1025_ID, device_adr, TW_WRITE);				// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX

	for(i=0;i<8;i++,seep_data++){
		twi_write(*seep_data);									// TWI  f[^
	}
	twi_stop();

	delay_ms(10);												// Wait 10mS
}

//***************************
// Seeprom USoCgf[^̏
//   seep_addr: VAddoqnl̃AhXiUSoCg؂AUoCgOj
//   seep_data: VAddoqnl̏ރf[^̗L鏊iUSoCgj
//  ߂l Ȃ
//***************************
void	seep1025_write_64(unsigned long seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_blk;								// rddoqnl̃AhX̃foCXAhXɕt镨
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	device_adr;
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x1ffc0;										// PQWoCgȂ̂łOQOOOOȏ̃AhX͗L蓾ȂBUSoCgŋ؂AhXɂ
	data_adr_blk = (unsigned char)((seep_addr >> 16) & 0x01);
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	device_adr = M24FC1025_ADDR;
	if(data_adr_blk != 0){										// ʂUSoCg̎
		device_adr |= M24FC1025_BLOCK;							// rbg𗧂Ă
	}

	twi_start(M24FC1025_ID, device_adr, TW_WRITE);				// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX

	for(i=0;i<64;i++,seep_data++){
		twi_write(*seep_data);									// TWI  f[^
	}
	twi_stop();

	delay_ms(10);												// Wait 10mS
}

// **************************
// *** SEEPROM TEST START ***
// **************************
void	seep1025_test(void)
{
	unsigned char	uc;
	unsigned char	wc = 0x12;


	seep1025_init();

	for(;;){
		led_on_off(1);							// LED ON
		seep1025_read_1(0x1ff10,&uc);
		wtod_02x((char *)disp_moji, uc);
		disp_lcd( 0,5,disp_moji);			// JEg \
		delay_ms(2000);						// 2000mS Delay
		led_on_off(0);							// LED OFF
		seep1025_write_1(0x1ff10, &wc);
		wc++;
		delay_ms(2000);						// 2000mS Delay
	}

}
// **************************
// **** SEEPROM TEST END ****
// **************************

#endif
