//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
// ԉxƒlۑvO
// File Name:Seeprom.h
//  wb_[t@C
//
// Serial EEPROM AT24C256
//
//  2011/09/09 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/08/06 Modify for All Model  Taishi(Ver 1.20) 
//*****************************************

#define	SEEP_ERR_TWI_START_TW_WRITE	1
#define	SEEP_ERR_TWI_WRITE			2
#define	SEEP_ERR_TWI_START_TW_READ	3
#define	SEEP_ERR_TWI_READ			4

#if		SEEPROM_IC == 1025		// Serial EEPROM:Microchip 24FC1025
extern	void			seep1025_init(void);
extern	unsigned char	seep1025_read_1(unsigned long seep_addr, unsigned char *seep_data);
extern	void			seep1025_read_2(unsigned long seep_addr, void *vseep_data);
extern	void			seep1025_read_8(unsigned long seep_addr, void *vseep_data);
extern	void			seep1025_read_64(unsigned long seep_addr, void *vseep_data);
extern	unsigned char	seep1025_write_1(unsigned long seep_addr, unsigned char *seep_data);
extern	void			seep1025_write_2(unsigned long seep_addr, void *vseep_data);
extern	void			seep1025_write_8(unsigned long seep_addr, void *vseep_data);
extern	void			seep1025_write_64(unsigned long seep_addr, void *vseep_data);
extern	void			seep1025_test(void);
 #define	seep_init		seep1025_init
 #define	seep_read_1		seep1025_read_1
 #define	seep_read_2		seep1025_read_2
 #define	seep_read_8		seep1025_read_8
 #define	seep_read_64	seep1025_read_64
 #define	seep_write_1	seep1025_write_1
 #define	seep_write_8	seep1025_write_8
 #define	seep_write_64	seep1025_write_64
 #define	seeprom_test	seep1025_test;
#else								// Serial EEPROM:AT24C256
extern	void			seep256_init(void);
extern	unsigned char	seep256_read_1(unsigned long seep_addr, unsigned char *seep_data);
extern	void			seep256_read_8(unsigned long seep_addr, void *vseep_data);
extern	void			seep256_read_64(unsigned long seep_addr, void *vseep_data);
extern	unsigned char	seep256_write_1(unsigned long seep_addr, unsigned char *seep_data);
extern	void			seep256_write_8(unsigned long seep_addr, void *vseep_data);
extern	void			seep256_write_64(unsigned long seep_addr, void *vseep_data);
extern	void			seep256_test(void);
 #define	seep_init		seep256_init
 #define	seep_read_1		seep256_read_1
 #define	seep_read_8		seep256_read_8
 #define	seep_read_64	seep256_read_64
 #define	seep_write_1	seep256_write_1
 #define	seep_write_8	seep256_write_8
 #define	seep_write_64	seep256_write_64
 #define	seeprom_test	seep256_test;
#endif

