//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:a_d.c
//
//  2011/12/17 Taishi New
//*****************************************

#include	<avr/io.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"gei_eeprom.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"timer.h"

#include	"a_d.h"

// **********************************************************
// ************************* A/D 0 **************************
// **********************************************************
#define			N_of_AD_data		16						// Q̊K̒lɌ

static	unsigned short	ad0_data[N_of_AD_data];
static	unsigned char	ad0_count;
//*****************************************
// A/D 0 Initial
//  ϊJn͂Ȃ
//*****************************************
void	ad0_init(void)
{
	unsigned char	i;

	PRR &= ~(1 << PRADC);													// ADC ғ
	delay_16us(100/16);														// POOr҂

	DDRC &= ~(1 << DDC0);													// PC0:Input
	DIDR0 |= (1 << ADC0D);													// ADC0 ޼ٓ͋֎~

	ad0_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad0_data[i] = 0;
	}

	ADMUX = ( (0 << REFS1) | (1 << REFS0) );								// AVCC REF, Select ADC0
	ADCSRA = ( (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, CK/128=1MHz/128=7.812kHz(128uS) --> 1.66mS
	ad0_active = 1;
}

//*****************************************
// A/D 0 Close
//*****************************************
void	ad0_close(void)
{
	ad0_active = 0;

	ADCSRA &= ~(1 << ADEN);																// A/Ds
	ADMUX &= ~( (1 << REFS1) | (1 << REFS0) );											// REF:External

	PRR |= (1 << PRADC);																// ADC ~
	delay_16us(100/16);																	// POOr҂

	DDRC |= (1 << DDC0);																// PC0:Output
	DIDR0 &= ~(1 << ADC0D);																// ADC0 ޼ِM
}

//*****************************************
// A/D0̕ϊl擾
//  ϊIĂȂ́@҂
//@߂l@ϊl
//*****************************************
unsigned short	ad0_get_one_data(void)
{
	unsigned short	us;

	ADCSRA |= (1 << ADSC);									// A/DϊJn

	while((ADCSRA & (1 << ADIF)) == 0){						// `^cϊ܂ő҂
		;
	}
	ADCSRA |= (1 << ADIF);								// `^cϊtO폜
	us = ADCW;

	return(us);
}
