//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:display.c
//
//  2011/12/17 Taishi New
//*****************************************
#include	<avr/pgmspace.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"lcd.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"timer.h"
#include	"Rtc_Rx8025.h"

#include	"display.h"



//*****************************************
// ^Cg\
//*****************************************
void	disp_title(void)
{
	disp_clear();												// Clear Display
	get_pgm_str(&str_title_1[0]);								// vÖ̃^Cg擾
	disp_lcd(0, 0, disp_moji);									// display LCD(16char x 2Line) Up Side
	get_pgm_str(&str_version[0]);								// vÖ̃o[W擾
	disp_lcd(7, 1, disp_moji);									// display LCD(16char x 2Line) Down Side

	delay_ms(3000);												// 2000mS Delay
	disp_clear();												// Clear Display
	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	disp_lcd(0,0,disp_moji);									// \
	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	disp_lcd(0,1,disp_moji);									// \

	delay_ms(3000);												// 2000mS Delay
	disp_clear();												// Clear Display
}
//*****************************************
// Nb\
//  Nb̃f[^͉LɗL
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_day;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_date;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
//*****************************************
void	disp_ymd_hms(void)
{
	disp_lcd(0,0, (unsigned char *)("20"));
	wtod_02x((char *)disp_moji,gRTC_year);
	disp_lcd(2,0, &disp_moji[0]);							// N\
	disp_lcd(4,0, (unsigned char *)("/"));
	wtod_02x((char *)disp_moji,gRTC_mon);
	disp_lcd(5,0, &disp_moji[0]);							// \
	disp_lcd(7,0, (unsigned char *)("/"));
	wtod_02x((char *)disp_moji,gRTC_day);
	disp_lcd(8,0, &disp_moji[0]);							// \

	wtod_02x((char *)disp_moji,gRTC_hou);
	disp_lcd(0,1, &disp_moji[0]);							// \
	disp_lcd(2,1, (unsigned char *)(":"));
	wtod_02x((char *)disp_moji,gRTC_min);
	disp_lcd(3,1, &disp_moji[0]);							// \
	disp_lcd(5,1, (unsigned char *)(":"));
	wtod_02x((char *)disp_moji,gRTC_sec);
	disp_lcd(6,1, &disp_moji[0]);							// b\
}
//*****************************************
// b\
//  b̃f[^͉LɗL
//	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_day;				// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_date;				// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
//*****************************************
void	disp_md_hms(void)
{
	wtod_02x((char *)disp_moji,gRTC_mon);
	disp_lcd(0,0, &disp_moji[0]);							// \
	disp_lcd(2,0, (unsigned char *)("/"));
	wtod_02x((char *)disp_moji,gRTC_day);
	disp_lcd(3,0, &disp_moji[0]);							// \
	disp_lcd(5,0, (unsigned char *)(" "));
	wtod_02x((char *)disp_moji,gRTC_hou);
	disp_lcd(6,0, &disp_moji[0]);							// \
	disp_lcd(8,0, (unsigned char *)(":"));
	wtod_02x((char *)disp_moji,gRTC_min);
	disp_lcd(9,0, &disp_moji[0]);							// \
	disp_lcd(11,0, (unsigned char *)(":"));
	wtod_02x((char *)disp_moji,gRTC_sec);
	disp_lcd(12,0, &disp_moji[0]);							// b\
}

//*****************************************
// RTC SẴWX^f[^\
//  ǂݏoWX^f[^ gRTC_reg[16] ɗL
//*****************************************
void	disp_all_register(void)
{
	unsigned char	i;

	for(i=0;i<8;i++){
		wtod_02x((char *)disp_moji,gRTC_reg[i]);
		disp_lcd(i*2,0, &disp_moji[0]);
	}

	for(i=0;i<8;i++){
		wtod_02x((char *)disp_moji,gRTC_reg[i+8]);
		disp_lcd(i*2,1, &disp_moji[0]);
	}

}
