//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:eeprom.c
//
//  2011/12/17 Taishi New
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"glb_dat.h"
#include	"utl.h"
#include	"lcd.h"
#include	"ondo_mizu.h"
#include	"Rtc_Rx8025.h"
#include	"uart.h"

#include	"gei_eeprom.h"

unsigned int	eep_mizu_nasi[4] EEMEM = {MIZU_NASI_DEFAULT,MIZU_NASI_DEFAULT,MIZU_NASI_DEFAULT};				// zl
unsigned int	eep_lcd_contrast[4] EEMEM = {LCD_CONTRAST_DEFAULT,LCD_CONTRAST_DEFAULT,LCD_CONTRAST_DEFAULT};	// kbcRgXgl
unsigned int	eep_interval[4] EEMEM = {INTERVAL_DEFAULT,INTERVAL_DEFAULT,INTERVAL_DEFAULT};					// Ԋu
unsigned int	eep_uart_bps[4] EEMEM = {UART_BPS_DEFAULT,UART_BPS_DEFAULT,UART_BPS_DEFAULT};					// ʐMaor



//*****************************************
// ʐMaor̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_uart_bps(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_uart_bps[i]);							// ʐMaor
	}

	uart_bps = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], MIZU_NASI_DEFAULT);	// 

	if(UART_BPS_MAX < uart_bps){												// ͈͊Oij̎
		uart_bps = UART_BPS_DEFAULT;											// ftHglɂ
	}else if(uart_bps < UART_BPS_MIN){											// ͈͊Oij̎
		uart_bps = UART_BPS_DEFAULT;											// ftHglɂ
	}

	for(i=0;i<3;i++){
		if(uart_bps != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_uart_bps[i],uart_bps);						// ʐMaor̕ۑ
		}
		eeprom_busy_wait();
	}
}
//*****************************************
// ʐMaor̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	save_uart_bps(void)
{
	unsigned char	t;

	for(t = 0; t < 3; t++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_uart_bps[t],uart_bps);	// ʐMaor̕ۑ
	}

	eeprom_busy_wait();
}
//*****************************************
// 臒l̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_mizu_nasi(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_mizu_nasi[i]);							// 臒l
	}

	mizu_nasi = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], MIZU_NASI_DEFAULT);	// 

	if(MIZU_NASI_MAX < mizu_nasi){												// ͈͊Oij̎
		mizu_nasi = MIZU_NASI_DEFAULT;											// ftHglɂ
	}else if(mizu_nasi < MIZU_NASI_MIN){										// ͈͊Oij̎
		mizu_nasi = MIZU_NASI_DEFAULT;											// ftHglɂ
	}

	for(i=0;i<3;i++){
		if(mizu_nasi != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_mizu_nasi[i],mizu_nasi);						// 臒l̕ۑ
		}
		eeprom_busy_wait();
	}
}
//*****************************************
// 臒l̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	save_mizu_nasi(void)
{
	unsigned char	t;

	for(t = 0; t < 3; t++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_mizu_nasi[t],mizu_nasi);	// 臒l̕ۑ
	}

	eeprom_busy_wait();
}
//*****************************************
// kbcRgXgl̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_lcd_contrast(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_lcd_contrast[i]);								// kbcRgXgl
	}

	lcd_contrast = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], LCD_CONTRAST_DEFAULT);	// 

	if(LCD_CONTRAST_MAX < lcd_contrast){												// ͈͊Oij̎
		lcd_contrast = LCD_CONTRAST_DEFAULT;											// ftHglɂ
	}else if(lcd_contrast < LCD_CONTRAST_MIN){											// ͈͊Oij̎
		lcd_contrast = LCD_CONTRAST_DEFAULT;											// ftHglɂ
	}

	for(i=0;i<3;i++){
		if(lcd_contrast != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_lcd_contrast[i],lcd_contrast);						// kbcRgXgl̕ۑ
		}
		eeprom_busy_wait();
	}
}
//*****************************************
// kbcRgXgl̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	save_lcd_contrast(void)
{
	unsigned char	t;

	for(t = 0; t < 3; t++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_lcd_contrast[t],lcd_contrast);	// kbcRgXgl̕ۑ
	}

	eeprom_busy_wait();
}
//*****************************************
// Ԋul̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_interval(void)
{
	unsigned char	i;
	unsigned int	i_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		i_dim[i] = eeprom_read_word(&eep_interval[i]);							// Ԋull
	}

	interval = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], INTERVAL_DEFAULT);	// 

	if(INTERVAL_MAX < interval){												// ͈͊Oij̎
		interval = INTERVAL_DEFAULT;											// ftHglɂ
	}else if(interval < INTERVAL_MIN){											// ͈͊Oij̎
		interval = INTERVAL_DEFAULT;											// ftHglɂ
	}

	for(i=0;i<3;i++){
		if(interval != i_dim[i]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_interval[i],interval);						// Ԋull̕ۑ
		}
		eeprom_busy_wait();
	}
}
//*****************************************
// Ԋul̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	save_interval(void)
{
	unsigned char	t;

	for(t = 0; t < 3; t++){
		eeprom_busy_wait();
		eeprom_write_word(&eep_interval[t],interval);	// Ԋul̕ۑ
	}

	eeprom_busy_wait();
}


//*****************************************
// ۑݒl̓ǂݏo
//*****************************************
void	read_config(void)
{
	load_mizu_nasi();									// 臒l̓ǂݏo
	load_lcd_contrast();								// kbcRgXgl̓ǂݏo
	load_interval();									// Ԋul̓ǂݏo
	load_uart_bps();									// ʐMaor̓ǂݏo
}

