//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:proc_comm.c
//
//  2012/11/19 Taishi  New (TAB4)
//*****************************************


#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"gei_eeprom.h"
#include	"timer.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"lcd.h"
#include	"uart.h"
#include	"port_bit.h"
#include	"DS18B20.h"
#include	"Seeprom.h"
#include	"Save_Dt.h"
#include	"Rtc_Rx8025.h"

#include	"proc_comm.h"


struct  FN_CMD  {
    char  *cmd;				/* Ҳڲ߂̕ */
    void	(*fn)(void);		/* ضݽ̖߂̏֐ */
    short	saigo;				/* r镶񂪂ŏI肩 PI */
        };


struct FN_CMD fn_cmd_se[];	/* R}hƏ֐ */

static	unsigned char	cmd_buf[32];
static	unsigned char	tx_buf[100];
static	unsigned char	cmd_pt;
static	unsigned char	n_of_tx;

unsigned char	str_comm_help[] PROGMEM    = {
	"[Rver] Read Program Version\r\n"							// [Rver] vOo[W߂
	"[Rdate] Read Program Completed Date & Time\r\n"			// [Rdate] ۸э쐬
	"[Rondo] Read Now Tenmperature\r\n"							// [Rondo] ݉xǂݏo/
	"[Rpt] Read Temperature Write Number\r\n"					// [Rpt] xݔԍǂ/
	"[Rdt9999] Read Temperature of No.9999\r\n"					// [Rdt9999] ۑxf[^ǂށiSԍ(POijwj
	"[Rmem] Read Memo. Data\r\n"								// [Rmem] f[^ǂށiPUj
	"[Wmem] Write Memo. Data\r\n"								// [Wmem] f[^iPUj
	"[Rstr] Read Start Time\r\n"								// [Rstr] JnǂށiPUj
	"[Ree123A] Read EEPROM(adr:123Ah)\r\n"						// [Ree123A] ddoqnl̃f[^ǂށiSPUiAhXwj
	"[Wee123A,1234] Write EEPROM(adr:123Ah, data:1234h)\r\n"	// [Wee123A,1234] ddoqnlɃf[^iSPUiAhX,SPUif[^wj
	"[Cset20080407234556] Set Clock(2008/04/07 23:45:56)\r\n"	// [Cset20080407234556]vɔNbݒ肷
	"[Cget] Read Clock(year,month,day,hour,minute,sec)\r\n"		// [Cget]v̔Nbǂ
	"[Calm2] Set Alarm Timing(0:NON, 1:Every Minute, 2:Every Hour, 3:Every Month)\r\n"	// [Calm2]v̊荞ݎݒ肷(0:~,1:,2:,3:)
	"[Cdat] Read Clock(All Data)\r\n"							// [Cdat]v̑Sf[^ǂ(PUiRQ)
	"[Cclr] Cler Alarm Flag(Timer Flag)\r\n"					// [Cclr]A[tOi^C}[tOjNA
	"[?] Help\r\n"												// [?] wv
	""															// I[
};

/********************************************************************/
/* [hf[^SAXL[iPUi or POi\jɒA	*/
/* Mobt@ɒǉ											*/
/********************************************************************/
static
void	ud_to_txbuf(unsigned short ud,int m)
{
	char		bf[6];

	if(m=='H'){
		wtod_04x(bf+1,ud);					/* S̃AXL[ɕϊ(HEX) */
	}else if ((m == 'D')&&(ud <= 9999)){
		wtod_05u(bf,ud);					/* S̃AXL[ɕϊ(DEC) */
	}else{
		lstrcpy(bf+1,"----");
	}
	lstrcat((char *)tx_buf,bf+1);
}



static	const	char	crlf[3]={0x0d,0x0a,0};
static	const	char	lf[2]={0x0a,0};

/********************/
/* R}h		*/
/********************/
void	invalid_pro(void)
{
	tx_buf[0] = 0x0a;
	tx_buf[1] = '?';
	tx_buf[2] = 0x0d;
	tx_buf[3] = 0x0a;
	n_of_tx = 4;
}

/********************/
/* njR}h		*/
/********************/
static
void	valid_pro(void)
{
	tx_buf[0] = 0x0a;
	tx_buf[1] = 'O';
	tx_buf[2] = 'K';
	tx_buf[3] = 0x0d;
	tx_buf[4] = 0x0a;
	n_of_tx = 5;
}

/************************************/
/* M							*/
/************************************/
void	tx_proc(void)
{
	unsigned char	i;

	for(i=0;n_of_tx > 0;i++,n_of_tx--){
		uart_tx_one(tx_buf[i]);				/* PoCgM */
	}
}

/************************************/
/* [Rver] o[W̓ǂݏo		*/
/************************************/
static
void	tvr_pro(void)
{
	lstrcpy((char *)tx_buf,(char *)lf);					/* ̑Mf[^ */
	get_pgm_str(&str_version[0]);						// vÖ̃o[W擾
	lstrcat((char *)tx_buf,(char *)disp_moji);
	lstrcat((char *)tx_buf,(char *)crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
}

/****************************/
/* [Rdate] ۸э쐬	*/
/* "Rdate" 					*/
/****************************/
static
void	tda_pro(void)
{
	lstrcpy((char *)tx_buf,(char *)lf);						/* ̑Mf[^ */
	get_pgm_str(&str_date[0]);								// vÖ̍쐬t
	lstrcat((char *)tx_buf,(char *)disp_moji);
	lstrcat((char *)tx_buf," ");
	get_pgm_str(&str_time[0]);								// vÖ̍쐬
	lstrcat((char *)tx_buf,(char *)disp_moji);
	lstrcat((char *)tx_buf,(char *)crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
}
/****************************************************/
/* [Rondo] ݉xǂݏo							*/
/* iZOɉx肵𒲂ׂ̂Ɏgj	*/
/* "Rondo" 											*/
/****************************************************/
static
void	rondo_pro(void)
{
	unsigned short	ud;

	ud = get_ondo();									/* ݂̉x擾 */

	lstrcpy((char *)tx_buf,(char *)lf);					/* ̑Mf[^ */
	ud_to_txbuf(ud,'H');								/* [hf[^SAXL[i10i\jɒAMobt@ɒǉ */
	lstrcat((char *)tx_buf,(char *)crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
}

/************************************/
/* [Rpt] xݔԍǂ		*/
/************************************/
static
void	rpt_pro(void)
{
	unsigned short	ud;

	lstrcpy((char *)tx_buf,(char *)lf);					/* ̑Mf[^ */
	ud=e2_ptdata_rd();									/* EEPROM̃f[^݃|C^ǂ*/
	ud_to_txbuf(ud,'D');								/* [hf[^SAXL[iPUi\jɒAMobt@ɒǉ */
	lstrcat((char *)tx_buf,(char *)crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
}

/************************************/
/* [Rdt9999] ۑxf[^ǂ	*/
/************************************/
static
void	rdt_pro(void)
{
	unsigned short	num;
	unsigned short	ud[4];
	unsigned short	r;

	if (cmd_buf[cmd_pt+4] == 0){
		if(chk_dec((char *)(&cmd_buf[cmd_pt]))==0){							/* AhXS 10i̎ */
			num = (unsigned short)(asc4tow((char *)(&cmd_buf[cmd_pt])));
			num = get_ondodata_adr(num);									/* xf[^ރAhX߂ */
			seep1025_read_8(num, (void *)ud);
			r = tasuuketu_ui(ud[0], ud[1], ud[2], 0xffff);
			lstrcpy((char *)tx_buf,(char *)lf);										/* ̑Mf[^ */
			ud_to_txbuf(r,'H');
			lstrcat((char *)tx_buf,crlf);
			n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
		}else{
			invalid_pro();													/* R}h */
		}
	}else{
		invalid_pro();														/* R}h */
	}
}

/********************************************/
/* [Ree] ddoqnl̃f[^ǂ			*/
/* " Ree123A "f[^ԍw肷(HEX\)	*/
/* "3C2E" QoCg̃f[^߂(HEX\)	*/
/********************************************/
static
void	te2r_pro(void)
{
	unsigned short	adr;
	unsigned short	ud;

	if (cmd_buf[cmd_pt+4] == 0){
		if(chk_hex((char *)(&cmd_buf[cmd_pt]))==0){				/* AhXSPUi̎ */
			adr = asch4tou((char *)(&cmd_buf[cmd_pt]));
			rd_pron_nword(adr,&ud,1);							/* wAhXw胏[h̓ǂݏo */
			lstrcpy((char *)tx_buf,(char *)lf);							/* ̑Mf[^ */
			ud_to_txbuf(ud,'H');
			lstrcat((char *)tx_buf,"H");
			lstrcat((char *)tx_buf,crlf);
			n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
		}else{
			invalid_pro();										/* R}h */
		}
	}else{
		invalid_pro();											/* R}h */
	}
}

/****************************************************/
/* [Wee] ddoqnlɃf[^					*/
/* " Wee123A,1234 "f[^ԍw肷(HEX\)	*/
/****************************************************/
static
void	te2w_pro(void)
{
	unsigned short	adr;
	unsigned short	ud;
	short			ok;

	ok = 0;
	if ((cmd_buf[cmd_pt+4] == ',')&&(cmd_buf[cmd_pt+9] == 0)){
		cmd_buf[cmd_pt+4] = 0;
		if(chk_hex((char *)(&cmd_buf[cmd_pt]))==0){				/* AhXSPUi̎ */
			adr = asch4tou((char *)(&cmd_buf[cmd_pt]));
			if(chk_hex((char *)(&cmd_buf[cmd_pt+5]))==0){		/* f[^SPUi̎ */
				ud = asch4tou((char *)(&cmd_buf[cmd_pt+5]));
				wr_pron_nword(adr,&ud);							/* wAhX 1[h̏ */
				ok = 1;
			}
		}
	}
	if (ok == 1){
		valid_pro();											/* njR}h */
	}else{
		invalid_pro();											/* R}h */
	}
}

/****************************/
/* [Rmem] f[^ǂ	*/
/****************************/
static
void	rmem_pro(void)
{
	lstrcpy((char *)tx_buf,(char *)lf);							/* ̑Mf[^ */
	e2_add_mem(tx_buf);									/* f[^ǉ */
	lstrcat((char *)tx_buf,crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
}

/****************************/
/* [Wmem] f[^	*/
/****************************/
static
void	wmem_pro(void)
{
	e2_set_mem(&(cmd_buf[cmd_pt]));		/* f[^ */

	valid_pro();						/* njR}h */
}

/****************************/
/* Jnǂ		*/
/* [Rstr]					*/
/****************************/
static
void	rstr_pro(void)
{
	lstrcpy((char *)tx_buf,(char *)lf);										/* ̑Mf[^ */
	e2_get_start_string(tx_buf);									/* f[^ǉ */
	lstrcat((char *)tx_buf,crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);

}

/********************************/
/* vɔNbݒ肷	*/
/*   [Cset20080407234556]		*/
/********************************/
static
void	cset_pro(void)
{
	char			bf[4];
	short			s;
	short			ok;

	ok = 0;
	if(lstrlen((char *)(&cmd_buf[cmd_pt]))==14){
		bf[0] = cmd_buf[cmd_pt+2];												/* N@Q */
		bf[1] = cmd_buf[cmd_pt+3];
		bf[2] = 0;
		s = asc4tow(bf);
		if((0 <= s)&&(s <= 99)){												/* lϊ */
			gRTC_year = (bf[0] & 0x0f);
			gRTC_year <<= 4;
			gRTC_year |= (bf[1] & 0x0f);

			bf[0] = cmd_buf[cmd_pt+4];											/*  */
			bf[1] = cmd_buf[cmd_pt+5];
			bf[2] = 0;
			s = asc4tow(bf);
			if((1 <= s)&&(s <= 12)){											/* lϊ */
				gRTC_mon = (bf[0] & 0x0f);
				gRTC_mon <<= 4;
				gRTC_mon |= (bf[1] & 0x0f);

				bf[0] = cmd_buf[cmd_pt+6];										/*  */
				bf[1] = cmd_buf[cmd_pt+7];
				bf[2] = 0;
				s = asc4tow(bf);
				if((1 <= s)&&(s <= 31)){										/* lϊ */
					gRTC_day = (bf[0] & 0x0f);
					gRTC_day <<= 4;
					gRTC_day |= (bf[1] & 0x0f);

					bf[0] = cmd_buf[cmd_pt+8];									/*  */
					bf[1] = cmd_buf[cmd_pt+9];
					bf[2] = 0;
					s = asc4tow(bf);
					if((0 <= s)&&(s <= 23)){									/* lϊ */
						gRTC_hou = (bf[0] & 0x0f);
						gRTC_hou <<= 4;
						gRTC_hou |= (bf[1] & 0x0f);

						bf[0] = cmd_buf[cmd_pt+10];								/*  */
						bf[1] = cmd_buf[cmd_pt+11];
						bf[2] = 0;
						s = asc4tow(bf);
						if((0 <= s)&&(s <= 59)){								/* lϊ */
							gRTC_min = (bf[0] & 0x0f);
							gRTC_min <<= 4;
							gRTC_min |= (bf[1] & 0x0f);

							bf[0] = cmd_buf[cmd_pt+12];							/* b */
							bf[1] = cmd_buf[cmd_pt+13];
							bf[2] = 0;
							s = asc4tow(bf);
							if((0 <= s)&&(s <= 59)){							/* lϊ */
								gRTC_sec = (bf[0] & 0x0f);
								gRTC_sec <<= 4;
								gRTC_sec |= (bf[1] & 0x0f);

								gRTC_wday = 1;

								rtc_write();									// RTC N 
								ok = 1;
							}
						}
					}
				}
			}
		}
	}

	if (ok == 1){
		valid_pro();														/* njR}h */
	}else{
		invalid_pro();														/* R}h */
	}
}

/************************************************/
/* Nb𕶎ɕϊĒǉ			*/
/*  *us:N̔z [5]NA[0]b	*/
/*      *bf:ϊ̕鏊				*/
//  Nb͈ȉ̕ϐɗL
//	unsigned char	gRTC_sec;				qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;				qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;				qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_day;				qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_date;				qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;				qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;				qsb Ñf[^ (BCD 0--99)
/************************************************/
static
void	add_conv_sec_year_to_asc(char *bf)
{

	wtod_02x(bf,gRTC_year);		// N
	bf += 2;
	wtod_02x(bf,gRTC_mon);		// 
	bf += 2;
	wtod_02x(bf,gRTC_day);		// 
	bf += 2;
	wtod_02x(bf,gRTC_hou);		// 
	bf += 2;
	wtod_02x(bf,gRTC_min);		// 
	bf += 2;
	wtod_02x(bf,gRTC_sec);		// b
}
/********************************/
/* v̔Nbǂ		*/
/*   [Cget]						*/
/********************************/
static
void	cget_pro(void)
{
	lstrcpy((char *)tx_buf,(char *)lf);				/* ̑Mf[^ */

	rtc_read();										// RTC N ǂݏo

	lstrcat((char *)tx_buf,"20");
	add_conv_sec_year_to_asc((char *)tx_buf);		/* ɕϊ */
	lstrcat((char *)tx_buf,(char *)crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);

}

/****************************************/
/* v̊ݎijݒ肷			*/
/*   [CalmX]							*/
/*   (X--> 0:~,1:,2:,3:)	*/
/****************************************/
static
void	calm_pro(void)
{
	unsigned short	alm;
	short			ok;

	ok = 0;
	if(cmd_buf[cmd_pt] == '0'){				// ~io͂Ȃj
		alm = 0;
		ok = 1;
	}else if(cmd_buf[cmd_pt] == '1'){		// (OOb̎j
		alm = 1;
		ok = 1;
	}else if(cmd_buf[cmd_pt] == '2'){		// (OOOOb̎j
		alm = 2;
		ok = 1;
	}else if(cmd_buf[cmd_pt] == '3'){		// (POOOOOOb̎j
		alm = 3;
		ok = 1;
	}

	if (ok == 1){
		interval = alm;
		save_interval();					// Ԋul̕ۑiۑ邾œ͕ύXȂj
		valid_pro();						/* njR}h */
	}else{
		invalid_pro();						/* R}h */
	}
}

/****************************************/
/* v̑Sf[^ǂ(PUiRQ)	*/
/*   [Cdat]								*/
/****************************************/
static
void	cdat_pro(void)
{
	int				i;
	char			bf[4];

	rtc_all_register_read();							// RTC SẴWX^f[^ǂݏo
														//  ǂݏof[^ gRTC_reg[16] ɓ

	lstrcpy((char *)tx_buf,(char *)lf);					/* ̑Mf[^ */

	for(i=0;i<16;i++){
		wtod_02x(bf,(unsigned short)(gRTC_reg[i]) );
		lstrcat((char *)tx_buf,bf);
	}

	lstrcat((char *)tx_buf,(char *)crlf);
	n_of_tx = (unsigned char)lstrlen((char *)tx_buf);
}

/********************************************/
/* A[tOi^C}[tOjNA	*/
/* [Cclr]									*/
/********************************************/
static
void	cclr_pro(void)
{
	rtc_inta_intb_clear();		// RTC /INTA /INTBM̃NA
	valid_pro();				/* njR}h */
}
/****************************************/
/* wv								*/
/* [?]									*/
/****************************************/
static
void	help_pro(void)
{
	unsigned char uc;
	unsigned char *puc;

	puc = str_comm_help;
	while(1){
		uc = pgm_read_byte(puc);
		if(uc == 0){									// ^[~l[^[̎
			break;
		}
		uart_tx_one(uc);								// UART TxD One Char
		puc++;
	}
}

struct FN_CMD fn_cmd_se[]={						/* R}hƏ֐ */
				{"Rver",	tvr_pro,	1 },	/* [Rver] vOo[W߂ */
				{"Rdate",	tda_pro,	1 },	/* [Rdate] ۸э쐬 */
				{"Rondo",	rondo_pro,	1 },	/* [Rondo] ݉xǂݏo */
				{"Rpt",		rpt_pro,	1 },	/* [Rpt] xݔԍǂ */
				{"Rdt",		rdt_pro,	0 },	/* [Rdt9999] ۑxf[^ǂށiSԍ(POijwj */
				{"Rmem",	rmem_pro,	1 },	/* [Rmem] f[^ǂށiPUj */
				{"Wmem",	wmem_pro,	0 },	/* [Wmem] f[^iPUj */
				{"Rstr",	rstr_pro,	1 },	/* [Rstr] JnǂށiPUj */
				{"Ree",		te2r_pro,	0 },	/* [Ree123A] ddoqnl̃f[^ǂށiSPUiAhXwj */
				{"Wee",		te2w_pro,	0 },	/* [Wee123A,1234] ddoqnlɃf[^iSPUiAhX,SPUif[^wj */
/* -------------------------- */

				{"Cset",	cset_pro,	0 },	/* [Cset20080407234556]vɔNbݒ肷 */
				{"Cget",	cget_pro,	1 },	/* [Cget]v̔Nbǂ */
				{"Calm",	calm_pro,	0 },	/* [Calm2]ṽA[ݒ肷(0:~,1:,2:,3:) */
				{"Cdat",	cdat_pro,	1 },	/* [Cdat]v̑Sf[^ǂ(PUiRQ) */
				{"Cclr",	cclr_pro,	1 },	/* [Cclr]A[tOi^C}[tOjNA */

				{"?",		help_pro,	1 },	/* [?] wv */

				{"",		invalid_pro,0 },	/* I[ */
			};

/********************************************************/
/* R}h											*/
/* ʐMR}h̏(ްcmd_buf[]ɓĂ)		*/
/*@֐ðقēނ̎̊֐		*/
/*@ĂяoB̎Acmd_ptɺނ̌̕	*/
/********************************************************/
static
void	cmd_proc(void)
{
	unsigned char	i;
	struct FN_CMD	*fn_cmd;
	char			bf[20];

	for(i=0;;i++){
		fn_cmd = (struct FN_CMD *)(&fn_cmd_se[i]);
		if(fn_cmd->cmd[0]==0){														/* Ȃ */
			(*(fn_cmd->fn))();
			break;
		}
		lstrcpy(bf,(char *)(fn_cmd->cmd));
		if(lstrncmp((char *)cmd_buf,bf,(short)lstrlen(bf))==0){						/* e[u̕iR}hjƈv */
			cmd_pt = (unsigned char)lstrlen(bf);									/* |C^[̏ꏊɂ */
			if((fn_cmd->saigo==0)||((fn_cmd->saigo==1)&&(cmd_buf[cmd_pt] == 0))){	/* S̔rIɂ͎͖̕ */
				if(lcd_active == 1){												// kbcL̎
					get_pgm_str(&str_space10[0]);									// vÖ̕("          ")擾
					disp_lcd(0, 1, disp_moji);										// display LCD(16char x 2Line) Down Side
					disp_lcd(0, 1, (unsigned char *)bf);							// display LCD(16char x 2Line) Down Side
				}
				(*(fn_cmd->fn))();
				break;
			}
		}
	}
	tx_proc();																		/* M */
}

//*****************************************
// ʐMiiv[vj
//*****************************************
void	proc_comm(void)
{
	unsigned char	c;
	int				d;

	rtc_set_interval(0);						// C^[oo͂Ȃ

	uart_init();								// UART Initial
	n_of_tx=0;
	cmd_pt = 0;
	if(lcd_active == 1){						// kbcL̎
		get_pgm_str(&str_comm[0]);				// vÖ̕("Communication")擾
		disp_lcd(0, 0, disp_moji);				// display LCD(16char x 2Line) Up Side
		if(uart_bps == 3){
			get_pgm_str(&str_9600[0]);			// vÖ̕("9600")擾
		}else if(uart_bps == 2){
			get_pgm_str(&str_4800[0]);			// vÖ̕("4800")擾
		}else if(uart_bps == 1){
			get_pgm_str(&str_2400[0]);			// vÖ̕("2400")擾
		}else{
			get_pgm_str(&str_1200[0]);			// vÖ̕("1200")擾
		}
		disp_lcd( 0,1, &disp_moji[0]);			// \

		get_pgm_str(&str_8_E_1[0]);				// vÖ̕(".8.E.1")擾
		disp_lcd( 4,1, &disp_moji[0]);			// \
	}

	for(;;){
		d = uart_rx_one();
		if(0 <= d){										/* Mf[^L */
			c = (d & 0xff);
			if ((c == 'R')||(c == 'W')||(c == 'C')){	/* 'R' 'W' 'C' ̎̓R}hobt@̓ɓ */
				cmd_pt=0;
			}
			if (c == 0x0d){								/* R}h̏I̎ */
				led_on_off(1);							// LED ON
				cmd_buf[cmd_pt]=0;
				cmd_proc();								/* R}h */	
				cmd_pt = 0;
				led_on_off(0);							// LED OFF
			}else{
				cmd_buf[cmd_pt]=c;						/* R}hobt@ɓ */
				if (cmd_pt < 30){
					cmd_pt++;
				}
			}

		}
	}

}
