//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:proc_init.c
//
//  2012/11/19 Taishi  New (TAB4)
//*****************************************


#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"Save_Dt.h"
#include	"glb_dat.h"
#include	"lcd.h"
#include	"port_bit.h"
#include	"Mega_Twi.h"
#include	"timer.h"
#include	"Rtc_Rx8025.h"

#include	"proc_init.h"


//*****************************************
// iiv[vj
//*****************************************
void	proc_init(void)
{
	unsigned char	i;

	rtc_set_interval(0);						// C^[oo͂Ȃ

	e2_ptdata_wr(0);							/* EEPROM̃f[^݃|C^Oɂ */
	e2_set_start_string((unsigned char *)"----------------");

	if(lcd_active == 1){						// kbcL̎
		get_pgm_str(&str_seep_init[0]);			// vÖ̕("SEEPROM INIT")擾
		disp_lcd(0, 0, disp_moji);				// display LCD(16char x 2Line) Up Side
		get_pgm_str(&str_done[0]);				// vÖ̕("DONE!")擾
		disp_lcd(2, 1, disp_moji);				// display LCD(16char x 2Line) DOWN Side
	}

/* iv[v */
	i=1;
	for(;;){
		delay_ms(1000);			/* 1S҂ */
		led_on_off(i);			// LED ON or OFF
		i ^= 1;
	}

}
