//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// j^\
//
// File Name:proc_moni.c
//
//  2012/12/09 Taishi New
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"lcd.h"
#include	"glb_dat.h"
#include	"utl.h"
#include	"gei_eeprom.h"
#include	"display.h"
#include	"ondo_mizu.h"
#include	"Rtc_Rx8025.h"
#include	"uart.h"
#include	"Mega_Twi.h"

#include	"proc_moni.h"

//*****************************************
// xɕϊij
//  @FPQrbgiWrbg{_ȉSrbgj
//*****************************************
static
void	set_ondo_moji(unsigned short us)
{
	char			bf[6];
	unsigned char	i;

	wtod_5u(bf, (us >> 4));					// 
	lstrcpy((char *)disp_moji,&bf[3]);
	lstrcat((char *)disp_moji,".");
	wtod_05u(bf, ((us & 0x000f) * 625));	// 
	for(i=4;1<i;i--){
		if(bf[i] != '0'){					// ÉfOf
			break;
		}else{
			bf[i] = ' ';
		}
	}
	lstrcat((char *)disp_moji,&bf[1]);
}

//*****************************************
// j^\
// 荞݉ŌĂ΂
//*****************************************
void	proc_moni(void)
{
	unsigned char	lSec;
	unsigned char	uc;
	unsigned short	lOndo;

	disp_clear();
	twi_init();														// TWI ݒigpJnj
	rtc_read();														// RTC N ǂݏo
	lSec = gRTC_sec;
	disp_ymd_hms();													// N\
	lOndo = get_ondo_mizu();										// ݂̉xƐ̗L擾iQ`Rbj
	set_ondo_moji(lOndo & 0x0fff);									// xɕϊij
	disp_lcd( 9,1, &disp_moji[0]);									// \
	if((lOndo & 0x4000)==0){										// L̎
		disp_lcd(11,0, (unsigned char *)"o");						// "o"\
	}else{
		disp_lcd(11,0, (unsigned char *)"x");						// "x"\
	}
	wtod_5u((char *)disp_moji, gAd_mizu);							// ZT@`^cl
	disp_lcd(12,0, &disp_moji[1]);									// \
	rtc_set_interval(interval);										// C^[oo͗L
	rtc_inta_clear();												// RTC /INTA M̃NA
	twi_close();													// TWI gpI

	wait_key_off();													// XCb`@܂ő҂
	tim_10ms_led = 20;
	while(1){
		if(tim_10ms_led == 0){										// QOOr̕\ikdcp^C}[pj
			led_on_off(0);											// LED OFF
			tim_10ms_led = 20;
			twi_init();												// TWI ݒigpJnj
			rtc_read();												// RTC N ǂݏo
			if(lSec != gRTC_sec){									// bω
				lSec = gRTC_sec;
				disp_ymd_hms();										// N\
				if((lSec & 0x0f)== 5){								// Tb̎ɁiPObɁj
					lOndo = get_ondo_mizu();						// ݂̉xƐ̗L擾iQ`Rbj
					set_ondo_moji(lOndo & 0x0fff);					// xɕϊij
					disp_lcd( 9,1, &disp_moji[0]);					// \
					if((lOndo & 0x4000)==0){						// L̎
						disp_lcd(11,0, (unsigned char *)"o");		// "o"\
					}else{
						disp_lcd(11,0, (unsigned char *)"x");		// "x"\
					}
					wtod_5u((char *)disp_moji, gAd_mizu);			// ZT@`^cl
					disp_lcd(12,0, &disp_moji[1]);					// \
				}
			}
			twi_close();											// TWI gpI
		}

		if(rtc_1h_flg != 0){										// qsbĂ鎞̂PԌoߗp
			twi_init();												// TWI ݒigpJnj
			rtc_inta_clear();										// RTC /INTA M̃NA
			twi_close();											// TWI gpI
			led_on_off(1);											// LED ON
			rtc_1h_flg = 0;
			tim_10ms_led = 100;
			EIMSK |= (1 << INT0);									// INT0 Interrupt Enable
		}

		uc = get_action_sw();										// XCb`Ԃ
		uc &= 0x0f;													// EXCb`ɂ
		if(uc != 0){												// ANVL鎞
			if(uc == SWR_OFF_LONG){									// ꂽ
				break;
			}
		}
	}

	cli();															// 荞ݕs
	twi_init();														// TWI ݒigpJnj
	rtc_set_interval(0);											// C^[oo͂Ȃ
	rtc_inta_clear();												// RTC /INTA M̃NA
	sei();															// 荞݉
}

