//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:settei.c
//
// 2013/03/17 Ver 0.02
//    ݒ胂[h@`^cl̕\ǉ
//    ݒlύXʂ̍ŏ ^Cg\ǉ
//    oxݒ莞iLl̒j@݂̐ZT[l̕\ǉ
//
//
//  2011/12/17 Taishi New
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>

#include	"ATmega328_ONDO2.h"
#include	"const_str.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"lcd.h"
#include	"glb_dat.h"
#include	"utl.h"
#include	"gei_eeprom.h"
#include	"display.h"
#include	"ondo_mizu.h"
#include	"Rtc_Rx8025.h"
#include	"uart.h"
#include	"proc_moni.h"

#include	"settei.h"

static	unsigned char	disp_hisigata = 0;

//*****************************************
// ۑ}[N̕\
//*****************************************
static
void	disp_save_mark(void)
{
	if(disp_hisigata == 1){								// ۑ}[N\vL
		lcd_icon_hisigata(1);							// Ђ`@ACR̕\
		tim_10ms_lcd = 100;								// \ԃZbg
		disp_hisigata = 2;
	}else if(disp_hisigata == 2){						// ۑ}[N\
		if(tim_10ms_lcd == 0){							// ^CAbv
			lcd_icon_hisigata(0);						// Ђ`@ACR̔\
			disp_hisigata = 0;
		}
	}
}
//*****************************************
// Zx̒
//*****************************************
static
void	proc_contrast(void)
{
	unsigned char	keta=0;
	unsigned char	kesu=1;
	unsigned char	uc;
	unsigned char	old_conrast;

	disp_clear();
	get_pgm_str(&str_lcd[0]);					// vÖ̕("LCD")擾
	disp_lcd(0, 0, disp_moji);					// display LCD(16char x 2Line) Up Side
	get_pgm_str(&str_contrast[0]);				// vÖ̕("CONTRAST")擾
	disp_lcd(4, 0, disp_moji);					// display LCD(16char x 2Line) Up Side

	wait_key_off();								// XCb`@܂ő҂
	old_conrast = lcd_contrast;					// ܂ł̒lۑ
	tim_10ms_led = 50;							// TOOrɃZbg
	while(1){
		if(tim_10ms_led == 0){												// TOOr̕\i`^cOp^C}[pj
			tim_10ms_led = 50;

			kesu ^= 1;														// o͒l̓_
			if(kesu == 0){													// _ł̓_̎
				led_on_off(1);												// LED ON
				wtod_02u((char *)disp_moji, lcd_contrast);					// o Data
				disp_lcd( 1,1, &disp_moji[0]);								// \
				get_pgm_str(&str_save[0]);									// vÖ̕("Save")擾
				disp_lcd( 5,1,disp_moji);									// \
				get_pgm_str(&str_exit[0]);									// vÖ̕("Exit")擾
				disp_lcd(10,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				led_on_off(0);												// LED OFF
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta < 2){
					disp_lcd(keta+1,1, &disp_moji[9]);						// Xy[X\
				}else if(keta == 2){
					disp_lcd( 5,1, &disp_moji[6]);							// Xy[X\
				}else{
					disp_lcd(10,1, &disp_moji[6]);							// Xy[X\
				}
			}
		}

		uc = get_action_sw();												// XCb`Ԃ
		uc &= 0x0f;															// EXCb`ɂ
		if(uc != 0){														// ANVL鎞
			if(uc == SWR_OFF_SHORT){										// Zꂽ
				keta++;
				if(3 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){									// ꂽ
				if(keta == 2){												// ۑ̏ꏊ
					save_lcd_contrast();									// kbcRgXgl̕ۑ
					old_conrast = lcd_contrast;								// ܂ł̒lۑ
					disp_hisigata = 1;										// ۑ}[N\v
				}else if(keta == 3){										// Ȉꏊ
					if(old_conrast != lcd_contrast){						// ۑlƍ̒lႤ
						lcd_contrast = old_conrast;							// ۑlɖ߂
						lcd_contrast_set();									// Contrast Set
					}
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){								// ꑱ
				if(keta == 0){												// PǑ
					if( ((lcd_contrast+10)/10) <= (LCD_CONTRAST_MAX/10) ){	// PǑőlȉ̎
						lcd_contrast += 10;
					}else{
						lcd_contrast = (LCD_CONTRAST_MIN/10)+(lcd_contrast % 10);
					}
				}else if(keta == 1){										// P̌
					if(lcd_contrast == LCD_CONTRAST_MAX){					// ől̎
						lcd_contrast = (lcd_contrast/10)*10;
					}else if( (lcd_contrast % 10) != 9 ){					// P̌XȊO̎
						lcd_contrast += 1;
					}else{
						lcd_contrast = (lcd_contrast/10)*10;
					}
				}
				if(LCD_CONTRAST_MAX < lcd_contrast){						// ͈͊Oij̎
					lcd_contrast = LCD_CONTRAST_MAX;						// őlɂ
				}else if(lcd_contrast < LCD_CONTRAST_MIN){					// ͈͊Oij̎
					lcd_contrast = LCD_CONTRAST_MIN;						// ŏlɂ
				}

				lcd_contrast_set();											// Contrast Set

				wtod_02u((char *)disp_moji, lcd_contrast);					// o͒l Data
				disp_lcd( 1,1, &disp_moji[0]);								// \
				kesu = 1;
			}
		}
		disp_save_mark();													// ۑ}[N̕\
	}
}
//*****************************************
// ʐMaor̒
//*****************************************
static
void	proc_uart_bps(void)
{
	unsigned char	keta=0;
	unsigned char	kesu=1;
	unsigned char	uc;
	unsigned char	old_bps;

	disp_clear();
	get_pgm_str(&str_uart[0]);								// vÖ̕("UART")擾
	disp_lcd(0, 0, disp_moji);								// display LCD(16char x 2Line) Up Side
	get_pgm_str(&str_bps[0]);								// vÖ̕("BPS")擾
	disp_lcd(5, 0, disp_moji);								// display LCD(16char x 2Line) Up Side

	wait_key_off();											// XCb`@܂ő҂
	old_bps = uart_bps;										// ܂ł̒lۑ
	tim_10ms_led = 50;										// TOOrɃZbg
	while(1){
		if(tim_10ms_led == 0){								// TOOr̕\
			tim_10ms_led = 50;

			kesu ^= 1;										// o͒l̓_
			if(kesu == 0){									// _ł̓_̎
				if(uart_bps == 3){
					get_pgm_str(&str_9600[0]);				// vÖ̕("9600")擾
				}else if(uart_bps == 2){
					get_pgm_str(&str_4800[0]);				// vÖ̕("4800")擾
				}else if(uart_bps == 1){
					get_pgm_str(&str_2400[0]);				// vÖ̕("2400")擾
				}else{
					get_pgm_str(&str_1200[0]);				// vÖ̕("1200")擾
				}
				disp_lcd( 0,1, &disp_moji[0]);				// \

				get_pgm_str(&str_save[0]);					// vÖ̕("Save")擾
				disp_lcd( 5,1,disp_moji);					// \
				get_pgm_str(&str_exit[0]);					// vÖ̕("Exit")擾
				disp_lcd(10,1,disp_moji);					// \
			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd( 0,1, &disp_moji[6]);			// Xy[X\
				}else if(keta == 1){
					disp_lcd( 5,1, &disp_moji[6]);			// Xy[X\
				}else{
					disp_lcd (10,1, &disp_moji[6]);			// Xy[X\
				}
			}
		}

		uc = get_action_sw();								// XCb`Ԃ
		uc &= 0x0f;											// EXCb`ɂ
		if(uc != 0){										// ANVL鎞
			if(uc == SWR_OFF_SHORT){						// Zꂽ
				keta++;
				if(2 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){					// ꂽ
				if(keta == 1){								// ۑ̏ꏊ
					save_uart_bps();						// ʐMaor̕ۑ
					old_bps = uart_bps;						// ܂ł̒lɕۑ
					disp_hisigata = 1;						// ۑ}[N\v
				}else if(keta == 2){						// Ȉꏊ
					uart_bps = old_bps;						// ܂ł̒lɖ߂
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){				// ꑱ
				if(keta == 0){								// P̌
					uart_bps++;
					if(UART_BPS_MAX < uart_bps){			// ͈͊Oij̎
						uart_bps = UART_BPS_MIN;			// ŏlɂ
					}

					if(uart_bps == 3){
						get_pgm_str(&str_9600[0]);			// vÖ̕("9600")擾
					}else if(uart_bps == 2){
						get_pgm_str(&str_4800[0]);			// vÖ̕("4800")擾
					}else if(uart_bps == 1){
						get_pgm_str(&str_2400[0]);			// vÖ̕("2400")擾
					}else{
						get_pgm_str(&str_1200[0]);			// vÖ̕("1200")擾
					}
					disp_lcd( 0,1, &disp_moji[0]);			// \
					kesu = 1;
				}
			}
		}
		disp_save_mark();									// ۑ}[N̕\
	}
}
//*****************************************
// ̒
//*****************************************
static
void	proc_meas_cycle(void)
{
	unsigned char	keta=0;
	unsigned char	kesu=1;
	unsigned char	uc;
	unsigned char	old_interval;

	disp_clear();
	get_pgm_str(&str_interval[0]);							// vÖ̕("INTERVAL")擾
	disp_lcd(0, 0, disp_moji);								// display LCD(16char x 2Line) Up Side

	wait_key_off();											// XCb`@܂ő҂
	old_interval = interval;								// ܂ł̒lۑ
	tim_10ms_led = 50;										// TOOrɃZbg
	while(1){
		if(tim_10ms_led == 0){								// TOOr̕\
			tim_10ms_led = 50;

			kesu ^= 1;										// o͒l̓_
			if(kesu == 0){									// _ł̓_̎
				if(interval == 3){
					get_pgm_str(&str_month[0]);				// vÖ̕("MONTH")擾
				}else if(interval == 2){
					get_pgm_str(&str_hour[0]);				// vÖ̕("HOUR")擾
				}else if(interval == 1){
					get_pgm_str(&str_minute[0]);			// vÖ̕("MINUTE")擾
				}else{
					get_pgm_str(&str_non[0]);				// vÖ̕("NON")擾
				}
				disp_lcd( 0,1, &disp_moji[0]);				// \

				get_pgm_str(&str_save[0]);					// vÖ̕("Save")擾
				disp_lcd( 7,1,disp_moji);					// \
				get_pgm_str(&str_exit[0]);					// vÖ̕("Exit")擾
				disp_lcd(12,1,disp_moji);					// \
			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd(0,1, &disp_moji[4]);			// Xy[X\
				}else if(keta == 1){
					disp_lcd( 7,1, &disp_moji[6]);			// Xy[X\
				}else{
					disp_lcd (12,1, &disp_moji[6]);			// Xy[X\
				}
			}
		}

		uc = get_action_sw();								// XCb`Ԃ
		uc &= 0x0f;											// EXCb`ɂ
		if(uc != 0){										// ANVL鎞
			if(uc == SWR_OFF_SHORT){						// Zꂽ
				keta++;
				if(2 < keta){
					keta = 0;
				}
			}else if(uc == SWR_ON_CONTINUE){				// ꑱ
				if(keta == 0){								// ̏ꏊ
					interval++;
					if(INTERVAL_MAX < interval){			// ͈͊Oij̎
						interval = INTERVAL_MIN;			// ŏlɂ
					}
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd(0,1, &disp_moji[4]);			// Xy[X\
					if(interval == 3){
						get_pgm_str(&str_month[0]);			// vÖ̕("MONTH")擾
					}else if(interval == 2){
						get_pgm_str(&str_hour[0]);			// vÖ̕("HOUR")擾
					}else if(interval == 1){
						get_pgm_str(&str_minute[0]);		// vÖ̕("MINUTE")擾
					}else{
						get_pgm_str(&str_non[0]);			// vÖ̕("NON")擾
					}
					disp_lcd( 0,1, &disp_moji[0]);			// \
					kesu = 1;
				}
			}else if(uc == SWR_OFF_LONG){					// ꂽ
				if(keta == 1){								// ۑ̏ꏊ
					save_interval();						// Ԋul̕ۑ
					old_interval = interval;				// ܂ł̒lɕۑ
					disp_hisigata = 1;						// ۑ}[N\v
				}else if(keta == 2){						// Ȉꏊ
					interval = old_interval;				// ܂ł̒lɖ߂
					break;
				}
			}
		}
		disp_save_mark();									// ۑ}[N̕\
	}
}
//*****************************************
// Ll̒
//*****************************************
static
void	proc_MIZU_level(void)
{
	unsigned char	keta=0;								//0:100̌, 1:10̌, 2:1̌
	unsigned char	kesu=1;
	unsigned char	uc;
	unsigned short	old_mizu_nasi;						// ܂ł̒l

	disp_clear();
	get_pgm_str(&str_mizu_level[0]);					// vÖ̕("MIZU LEVEL")擾
	disp_lcd(0, 0, disp_moji);							// display LCD(16char x 2Line) Up Side

	wait_key_off();										// XCb`@܂ő҂
	old_mizu_nasi = mizu_nasi;							// ܂ł̒lɕۑ
	mizu_initial();										// Ver0.02 ZT֌W̏ݒigpJnj
	tim_10ms_led = 50;									// TOOrɃZbg
	while(1){
		if(tim_10ms_led == 0){												// TOOr̕\i`^cOp^C}[pj
			tim_10ms_led = 50;

			kesu ^= 1;														// o͒l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji, mizu_nasi);						// o Data
				disp_lcd( 1,1, &disp_moji[2]);								// \
				get_pgm_str(&str_save[0]);									// vÖ̕("Save")擾
				disp_lcd( 5,1,disp_moji);									// \
				get_pgm_str(&str_exit[0]);									// vÖ̕("Exit")擾
				disp_lcd(10,1,disp_moji);									// \
				gAd_mizu =mizu_rd();										// Ver0.02 ̗L薳̃f[^ǂ
				wtod_5u((char *)disp_moji, gAd_mizu);						// Ver0.02 ZT@`^cl
				disp_lcd(12,0, &disp_moji[1]);								// Ver0.02 \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta < 3){
					disp_lcd(keta+1,1, &disp_moji[9]);						// Xy[X\
				}else if(keta == 3){
					disp_lcd( 5,1, &disp_moji[6]);							// Xy[X\
				}else{
					disp_lcd(10,1, &disp_moji[6]);							// Xy[X\
				}
			}
		}

		uc = get_action_sw();												// XCb`Ԃ
		uc &= 0x0f;															// EXCb`ɂ
		if(uc != 0){														// ANVL鎞
			if(uc == SWR_OFF_SHORT){										// Zꂽ
				keta++;
				if(4 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){									// ꂽ
				if(keta == 3){												// ۑ̏ꏊ
					save_mizu_nasi();										// 臒l̕ۑ
					old_mizu_nasi = mizu_nasi;								// ܂ł̒lɕۑ
					disp_hisigata = 1;										// ۑ}[N\v
				}else if(keta == 4){										// Ȉꏊ
					mizu_nasi = old_mizu_nasi;								// ܂ł̒lɖ߂
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){								// ꑱ
				if(keta == 0){												// POǑ
					if( (mizu_nasi/100) < (MIZU_NASI_MAX/100) ){			// POǑőlȉ̎
						mizu_nasi += 100;
					}else{
						mizu_nasi = (MIZU_NASI_MIN/100)+(mizu_nasi % 100);
					}
				}else if(keta == 1){										// PǑ
					if( ((mizu_nasi % 100)/10) != 9 ){						// PǑXȊO̎
						mizu_nasi += 10;
					}else{
						mizu_nasi = ((mizu_nasi/100)*100)+(mizu_nasi % 10);
					}
				}else if(keta == 2){										// P̌
					if( (mizu_nasi % 10) != 9 ){							// P̌XȊO̎
						mizu_nasi += 1;
					}else{
						mizu_nasi = ((mizu_nasi/10)*10);
					}
				}
				if(MIZU_NASI_MAX < mizu_nasi){								// ͈͊Oij̎
					mizu_nasi = MIZU_NASI_MAX;								// őlɂ
				}else if(mizu_nasi < MIZU_NASI_MIN){						// ͈͊Oij̎
					mizu_nasi = MIZU_NASI_MIN;								// ŏlɂ
				}

				wtod_05u((char *)disp_moji, mizu_nasi);						// o͒l Data
				disp_lcd( 1,1, &disp_moji[2]);								// \
				kesu = 1;
			}
		}
		disp_save_mark();													// ۑ}[N̕\
	}
	mizu_close();									// Ver0.02 ZT֌W̏IݒigpIj
}
//*****************************************
// v̒
//*****************************************
static
void	proc_time_adj(void)
{
	unsigned char	keta=0;							//0:100̌, 1:10̌, 2:1̌
	unsigned char	kesu=1;
	unsigned char	uc;
	unsigned char	lRTC_sec;						// qsb b̃f[^ (BCD 0--59)
	unsigned char	lRTC_min;						// qsb ̃f[^ (BCD 0--59)
	unsigned char	lRTC_hou;						// qsb ̃f[^ (BCD 0--23j
	unsigned char	lRTC_day;						// qsb ̃f[^ (BCD 1--31)
	unsigned char	lRTC_mon;						// qsb ̃f[^ (BCD 1--12j
	unsigned char	lRTC_year;						// qsb Ñf[^ (BCD 0--99)

	disp_clear();

	wait_key_off();									// XCb`@܂ő҂
	tim_10ms_led = 50;								// TOOrɃZbg

	rtc_read();										// RTC N ǂݏo
	lRTC_sec = gRTC_sec;							// qsb b̃f[^ (BCD 0--59)
	lRTC_min = gRTC_min;							// qsb ̃f[^ (BCD 0--59)
	lRTC_hou = gRTC_hou;							// qsb ̃f[^ (BCD 0--23j
	lRTC_day = gRTC_day;							// qsb ̃f[^ (BCD 1--31)
	lRTC_mon = gRTC_mon;							// qsb ̃f[^ (BCD 1--12j
	lRTC_year = gRTC_year;							// qsb Ñf[^ (BCD 0--99)

	disp_lcd( 5,0,(unsigned char *)"20");			// \
	disp_lcd( 9,0,(unsigned char *)"/");			// \
	disp_lcd(12,0,(unsigned char *)"/");			// \
	disp_lcd( 2,1,(unsigned char *)":");			// \
	disp_lcd( 5,1,(unsigned char *)":");			// \
	while(1){
		if(tim_10ms_led == 0){								// TOOr̕\i`^cOp^C}[pj
			tim_10ms_led = 50;

			kesu ^= 1;										// o͒l̓_
			if(kesu == 0){									// _ł̓_̎
				get_pgm_str(&str_exit[0]);					// vÖ̕("Exit")擾
				disp_lcd( 0,0,disp_moji);					// \
				wtod_02x((char *)disp_moji, lRTC_year);		// o Data
				disp_lcd( 7,0, disp_moji);					// \
				wtod_02x((char *)disp_moji, lRTC_mon);		// o Data
				disp_lcd(10,0, disp_moji);					// \
				wtod_02x((char *)disp_moji, lRTC_day);		// o Data
				disp_lcd(13,0, disp_moji);					// \
				wtod_02x((char *)disp_moji, lRTC_hou);		// o Data
				disp_lcd( 0,1, disp_moji);					// \
				wtod_02x((char *)disp_moji, lRTC_min);		// o Data
				disp_lcd( 3,1, disp_moji);					// \
				wtod_02x((char *)disp_moji, lRTC_sec);		// o Data
				disp_lcd( 6,1, disp_moji);					// \

				get_pgm_str(&str_save[0]);					// vÖ̕("Save")擾
				disp_lcd( 9,1,disp_moji);					// \
			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd( 0,0, &disp_moji[6]);			// Xy[X\
				}else if(keta == 1){
					disp_lcd( 7,0, &disp_moji[9]);			// Xy[X\
				}else if(keta == 2){
					disp_lcd( 8,0, &disp_moji[9]);			// Xy[X\
				}else if(keta == 3){
					disp_lcd(10,0, &disp_moji[9]);			// Xy[X\
				}else if(keta == 4){
					disp_lcd(11,0, &disp_moji[9]);			// Xy[X\
				}else if(keta == 5){
					disp_lcd(13,0, &disp_moji[9]);			// Xy[X\
				}else if(keta == 6){
					disp_lcd(14,0, &disp_moji[9]);			// Xy[X\
				}else if(keta == 7){
					disp_lcd( 0,1, &disp_moji[9]);			// Xy[X\
				}else if(keta == 8){
					disp_lcd( 1,1, &disp_moji[9]);			// Xy[X\
				}else if(keta == 9){
					disp_lcd( 3,1, &disp_moji[9]);			// Xy[X\
				}else if(keta == 10){
					disp_lcd( 4,1, &disp_moji[9]);			// Xy[X\
				}else if(keta == 11){
					disp_lcd( 6,1, &disp_moji[9]);			// Xy[X\
				}else if(keta == 12){
					disp_lcd( 7,1, &disp_moji[9]);			// Xy[X\
				}else if(keta == 13){
					disp_lcd( 9,1, &disp_moji[6]);			// Xy[X\
				}
			}
		}

		uc = get_action_sw();								// XCb`Ԃ
		uc &= 0x0f;											// EXCb`ɂ
		if(uc != 0){										// ANVL鎞
			if(uc == SWR_OFF_SHORT){						// Zꂽ
				keta++;
				if(13 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){					// ꂽ
				if(keta == 13){								// ۑ̏ꏊ
					lcd_icon_hisigata(1);					// Ђ`@ACR̕\
					gRTC_sec = lRTC_sec;					// qsb b̃f[^ (BCD 0--59)
					gRTC_min = lRTC_min;					// qsb ̃f[^ (BCD 0--59)
					gRTC_hou = lRTC_hou;					// qsb ̃f[^ (BCD 0--23j
					gRTC_day = lRTC_day;					// qsb ̃f[^ (BCD 1--31)
					gRTC_mon = lRTC_mon;					// qsb ̃f[^ (BCD 1--12j
					gRTC_year = lRTC_year;					// qsb Ñf[^ (BCD 0--99)
					rtc_write();							// RTC N 
					disp_hisigata = 1;						// ۑ}[N\v
				}else if(keta == 0){						// Ȉꏊ
					break;
				}
			}else if(uc == SWR_ON_CONTINUE){				// ꑱ
				if(keta == 1){								// NPǑ
					if( (lRTC_year&0xf0) < 0x90){			// PǑXȉ̎
						lRTC_year += 0x10;
					}else{
						lRTC_year = (lRTC_year & 0x0f);
					}
				}else if(keta == 2){						// NP̌
					if( (lRTC_year &0x0f) < 0x09 ){			// PǑXȉ̎
						lRTC_year += 0x01;
					}else{
						lRTC_year = (lRTC_year & 0xf0);
					}
				}else if(keta == 3){						// PǑ
					if( 0x10 <= lRTC_mon){					// POȏ̎
						lRTC_mon = 0x01;
					}else if( lRTC_mon <= 0x02){			// Qȉ̎
						lRTC_mon += 0x10;
					}
				}else if(keta == 4){						// P̌
					if( 0x12 <= lRTC_mon){					// PQȏ̎
						lRTC_mon = 0x01;
					}else if(lRTC_mon == 0x09 ){			// X̎
						lRTC_mon = 0x10;
					}else{
						lRTC_mon += 0x01;
					}
				}else if(keta == 5){						// PǑ
					if(0x30 == lRTC_day){					// RO̎
						lRTC_day = 0x10;
					}else if(0x31 == lRTC_day){				// RP̎
						lRTC_day &= 0x0f;
					}else if((lRTC_mon == 0x02) & (0x20 == lRTC_day)){			// QłQO̎
						lRTC_day = 0x10;
					}else if((lRTC_mon == 0x02) & (0x21 <= lRTC_day)){			// QłQPȏ̎
						lRTC_day &= 0x0f;
					}else{
						lRTC_day += 0x10;
					}
				}else if(keta == 6){						// P̌
					if(((lRTC_mon == 0x04)|(lRTC_mon == 0x06)|(lRTC_mon == 0x09)|(lRTC_mon == 0x11)) & ( 0x30 <= lRTC_day)){	// ̌łROȏ̎
						lRTC_day = 0xf0;
					}else if((((lRTC_year%4)!=0)&&(lRTC_mon == 0x02)) & (0x28 <= lRTC_day)){	// Qi邤NłȂjłQWȏ̎
						lRTC_day &= 0xf0;
					}else if((((lRTC_year%4)==0)&&(lRTC_mon == 0x02)) & (0x29 <= lRTC_day)){	// Qi邤NjłQXȏ̎
						lRTC_day &= 0xf0;
					}else if( 0x31 <= lRTC_day){			// ̌łRPȏ̎
						lRTC_day = 0xf0;
					}else if( (lRTC_day & 0x0f) == 0x09 ){	// X̎
						lRTC_day &= 0xf0;
					}else{
						lRTC_day += 0x01;
					}
				}else if(keta == 7){						// PǑ
					if( 0x23 < (lRTC_hou + 0x10)){			// POĂQR𒴂鎞
						lRTC_hou &= 0x0f;
					}else{
						lRTC_hou += 0x10;
					}
					wtod_02x((char *)disp_moji, lRTC_hou);	// o Data
					disp_lcd( 0,1, disp_moji);				// \
				}else if(keta == 8){						// P̌
					if(0x23 < (lRTC_hou + 0x01)){			// PĂQR𒴂鎞
						lRTC_hou &= 0xf0;
					}else if(0x09 <= (lRTC_hou & 0x0f)){	// Xȏ̎
						lRTC_hou &= 0xf0;
					}else{
						lRTC_hou += 0x01;
					}
				}else if(keta == 9){						// PǑ
					if( 0x59 < (lRTC_min + 0x10)){			// POĂTX𒴂鎞
						lRTC_min &= 0x0f;
					}else{
						lRTC_min += 0x10;
					}
				}else if(keta == 10){						// P̌
					if(0x09 <= (lRTC_min & 0x0f)){			// Xȏ̎
						lRTC_min &= 0xf0;
					}else{
						lRTC_min += 0x01;
					}
				}else if(keta == 11){						// PǑ
					if( 0x59 < (lRTC_sec + 0x10)){			// POĂTX𒴂鎞
						lRTC_sec &= 0x0f;
					}else{
						lRTC_sec += 0x10;
					}
				}else if(keta == 12){						// P̌
					if(0x09 <= (lRTC_sec & 0x0f)){			// Xȏ̎
						lRTC_sec &= 0xf0;
					}else{
						lRTC_sec += 0x01;
					}
				}
				kesu = 1;
			}
		}
		disp_save_mark();									// ۑ}[N̕\
	}
}
//*****************************************
//@ڂ̕\ij
// @FXy[X\鍀ڔԍiO`TjAȊO̒lł͑SĂ\
//*****************************************
static
void	disp_koumoku_config(unsigned char sel)
{
	unsigned char	bf[12];

	get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
	lstrcpy((char *)bf, (char *)disp_moji);

	if(sel == 0){								// OԂw
		disp_lcd( 0, 0, &bf[7]);				// Xy[X\
	}else{
		get_pgm_str(&str_lcd[0]);				// vÖ̕("LCD")擾
		disp_lcd( 0, 0, disp_moji);				// display LCD(16char x 2Line) Up Side
	}

	if(sel == 1){								// PԂw
		disp_lcd( 4, 0, &bf[6]);				// Xy[X\
	}else{
		get_pgm_str(&str_time_adj[0]);			// vÖ̕("TIME")擾
		disp_lcd( 4, 0, disp_moji);				// display LCD(16char x 2Line) Up Side
	}

	if(sel == 2){								// QԂw
		disp_lcd( 9, 0, &bf[6]);				// Xy[X\
	}else{
		get_pgm_str(&str_mizu[0]);				// vÖ̕("MIZU")擾
		disp_lcd(9, 0, disp_moji);				// display LCD(16char x 2Line) Up Side
	}

	if(sel == 3){								// RԂw
		disp_lcd( 0, 1, &bf[4]);				// Xy[X\
	}else{
		get_pgm_str(&str_intval[0]);			// vÖ̕("INTVAL")擾
		disp_lcd( 0, 1, disp_moji);				// display LCD(16char x 2Line) Down Side
	}

	if(sel == 4){								// SԂw
		disp_lcd( 7, 1, &bf[7]);				// Xy[X\
	}else{
		get_pgm_str(&str_bps[0]);				// vÖ̕("BPS")擾
		disp_lcd( 7, 1, disp_moji);				// display LCD(16char x 2Line) Down Side
	}

	if(sel == 5){								// TԂw
		disp_lcd(11, 1, &bf[6]);				// Xy[X\
	}else{
		get_pgm_str(&str_moni[0]);				// vÖ̕("MONI")擾
		disp_lcd(11, 1, disp_moji);				// display LCD(16char x 2Line) Down Side
	}
}

//*****************************************
// ݒlύX or ۑf[^\AM̑I
//  kbc̔ZAiqsbݎjALEl
//*****************************************
void	select_config_savedata(void)
{
	unsigned char	uc;
	unsigned char	kesu=0;
	unsigned char	keta=0;

	rtc_set_interval(0);						// C^[oo͂Ȃ

	if(lcd_active == 1){						// kbcLXCb`Ă͂̎
		lcd_contrast = LCD_CONTRAST_DEFAULT;	// ftHgZxɂ
		save_lcd_contrast();					// kbcRgXgl̕ۑ
	}

	init_lcd();									// Init. LCD

	disp_koumoku_config(0xff);					//@ڂ̕\iSj
	wait_sw_off();								// XCb`@܂ő҂	iݖgpj

	disp_clear();
	disp_title();								// Ver0.02 ^Cg\

	Timer2_init();								// Timer2 Initial
	tim_10ms_led = 50;							// TOOrɃZbg
	sei();										// 荞݉
	while(1){
		if(tim_10ms_led == 0){								// TOOr̕\i`^cOp^C}[pj
			tim_10ms_led = 50;

			kesu ^= 1;										// o͒l̓_
			if(kesu == 0){									// _ł̓_̎
				disp_koumoku_config(0xff);					//@ڂ̕\iSj
			}else{											// _ł̖ł̎
				if(keta == 5){								// j^
					disp_koumoku_config(5);					//@ڂ̕\iTȊOj
				}else if(keta == 4){						// ʐMaor
					disp_koumoku_config(4);					//@ڂ̕\iSȊOj
				}else if(keta == 3){						// 
					disp_koumoku_config(3);					//@ڂ̕\iRȊOj
				}else if(keta == 2){						// 臒l
					disp_koumoku_config(2);					//@ڂ̕\iQȊOj
				}else if(keta == 1){						// 
					disp_koumoku_config(1);					//@ڂ̕\iPȊOj
				}else if(keta == 0){						// Zx
					disp_koumoku_config(0);					//@ڂ̕\iOȊOj
				}
			}
		}
		uc = get_action_sw();								// XCb`Ԃ
		uc &= 0x0f;											// EXCb`ɂ
		if(uc != 0){										// ANVL鎞
			if(uc == SWR_OFF_SHORT){						// Zꂽ
				keta++;
				if(5 < keta){
					keta = 0;
				}
			}else if(uc == SWR_OFF_LONG){					// ꂽ
				if(keta == 5){								// lnmh̏ꏊ
					proc_moni();							// j^\
				}else if(keta == 4){						// aoȑꏊ
					proc_uart_bps();						// ʐMaor̒
				}else if(keta == 3){						// ̏ꏊ
					proc_meas_cycle();						// ̒
				}else if(keta == 2){						// ̏ꏊ
					proc_MIZU_level();						// Ll̒
				}else if(keta == 1){						// v̏ꏊ
					proc_time_adj();						// v̒
				}else if(keta == 0){						// Zx̏ꏊ
					proc_contrast();						// Zx̒
				}
				disp_clear();
				lcd_icon_hisigata(0);						// Ђ`@ACR̔\
				disp_hisigata = 0;
			}
		}
	}

}
