//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:uart.c
//
//  2011/12/17 Taishi New
//*****************************************

#include	<avr/io.h>

#include	"ATmega328_ONDO2.h"
#include	"timer.h"

#include	"uart.h"

unsigned short	uart_bps = 3;									// BPS 0:1200, 1:2400, 2:4800, 3:9600
// **********************************************************
// ************************** UART **************************
// **********************************************************
//***************************
// UART Initial
//***************************
void	uart_init(void)
{
#ifdef			UART_ARI										// VAʐML̎
	PRR &= ~(1 << PRUSART0);									// UART0 ғ
#ifdef	MHz_1
	delay_16us(100/16);											// POOr҂
#else	//MHz_1
	delay_2us(100/2);											// POOr҂
#endif	//MHz_1

	if(uart_bps == 3){											// 9600BPS
		UBRR0  = BPS_4800;
		UCSR0A |= (1 << U2X0);
	}else if(uart_bps == 2){									// 4800BPS
		UBRR0  = BPS_4800;
		UCSR0A &= ~(1 << U2X0);
	}else if(uart_bps == 1){									// 2400BPS
		UBRR0  = BPS_2400;
		UCSR0A &= ~(1 << U2X0);
	}else{														// 1200BPS
		UBRR0  = BPS_1200;
		UCSR0A &= ~(1 << U2X0);
	}
//	UCSR0C = (V_PARITY_NON | V_DATA_8);	// peBAf[^
	UCSR0C = (V_PARITY_EVN | V_DATA_8);	// peBAf[^

	UCSR0B |= ((1 << TXEN0) | (1 << RXEN0));
#endif			//UART_ARI										// VAʐML̎

}
//***************************
// UART Close
//***************************
void	uart_close(void)
{
#ifdef			UART_ARI										// VAʐML̎
	PRR |= (1 << PRUSART0);										// ~
	UCSR0B &= ~((1 << TXEN0) | (1 << RXEN0));
#ifdef	MHz_1
	delay_16us(100/16);											// POOr҂
#else	//MHz_1
	delay_2us(100/2);											// POOr҂
#endif	//MHz_1
#endif			//UART_ARI										// VAʐML̎

}

//***************************
// UART RxD One Char
//  荞݂gȂ
//  ߂l }CiX̒lFMf[^
//         [ȏ̒lFMf[^
//***************************
short	uart_rx_one(void)
{
	short	r;
	unsigned char	ucsr;

	r = -1;
#ifdef			UART_ARI										// VAʐML̎
	ucsr = UCSR0A;
	if((ucsr & (1 << RXC0)) != 0){								// Mf[^L̎
		r = UDR0;

		if((ucsr & (1 << FE0)) != 0){							// t[~OG[
			r = -2;
		}else if((ucsr & (1 << DOR0)) != 0){					// I[o[G[
			r = -3;
		}else if((ucsr & (1 << UPE0)) != 0){					// pBeB[G[
			r = -4;
		}
	}

#endif			//UART_ARI										// VAʐML̎

	return(r);
}
//***************************
// UART TxD One Char
//  荞݂gȂ
//***************************
void	uart_tx_one(unsigned char uc)
{
#ifdef			UART_ARI										// VAʐML̎
	while((UCSR0A & (1 << UDRE0)) == 0){
		;
	}
	UDR0 = uc;
#endif			//UART_ARI										// VAʐML̎
}
//***************************
// UART TxD String
//  荞݂gȂ
//***************************
void	uart_tx_str(char *str)
{
#ifdef			UART_ARI										// VAʐML̎
	while(*str != 0){
		uart_tx_one((unsigned char)(*str));
		str++;
	}
#endif			//UART_ARI										// VAʐML̎
}
//***************************
// UART TxD String + CR + LF
//***************************
void	uart_tx_str_crlf(char *str)
{
	uart_tx_str(str);											// UART TxD String
	uart_tx_one(0x0d);											// CR
	uart_tx_one(0x0a);											// LF
}

