//*****************************************
// AVR ATmega328 Temperature Program
// CPU Clock:1MHz
//   iq[Yf[^@āAOIV[^(8MHz)ɂj
// ԉxƒlۑvO
//
// File Name:utl.c
//
//  2011/12/17 Taishi New
//*****************************************

#include	"ATmega328_ONDO2.h"
#include	"utl.h"

// **********************************************************
// ************************ Utility *************************
// **********************************************************
/****************************************/
/* ̒߂					*/
/*@߂ĺ@oCg					*/
/****************************************/
int	lstrlen(const char *b1)
{
	int	r;

	r=0;
	while(*b1 != 0){
		b1++;
		r++;
	}
	return(r);
}
#if	0
/****************************************/
/* ̎w蕶̃T[`			*/
/*@߂ĺ@w蕶̏̃|C^[	*/
/*@@@@@@Ȃ0			*/
/****************************************/
char *lstrchr(const char *b1,const int n)
{
	for(;;){
		if ((int)(*b1) == n){
			break;
		}else if (*b1 == 0x00){
			b1 = (char *)0;
			break;
		}
		b1++;
	}
	return((char *)b1);
}
#endif
#if	0
/********************************/
/* ̎w蕶̃Rs[	*/
/*@߂ĺ@Ȃ				*/
/********************************/
void	lstrncpy(char *b1,const char *b2,const short n)
{
	short	i;

	for(i=0;i<n;i++){
		*b1 = *b2;
		b1++;
		b2++;
	}
}
#endif

/************************/
/* ̃Rs[		*/
/*@߂ĺ@Ȃ		*/
/************************/
void	lstrcpy(char *b1,const char *b2)
{
	while(*b2 != 0){
		*b1 = *b2;
		b1++;
		b2++;
	}
	*b1=0;
}
/****************************************/
/* ̎w蕶̔r				*/
/*@߂ĺ@SēɂO			*/
/*@@@@@@PłႤ͂OȊO	*/
/****************************************/
int	lstrncmp(const char *b1,const char *b2,const short n)
{
	int	r;
	short	i;

	for(i=0;i<n;i++){
		r = ((int)(*b1) - (int)(*b2));
		b1++;
		b2++;
		if ( r != 0){
			break;
		}
	}
	return(r);
}

#if	0
/****************************************/
/* ̂̔r						*/
/*@߂ĺ@SēɂO			*/
/*@@@@@@PłႤ͂OȊO	*/
/****************************************/
int	lstrcmp(const char *b1,const char *b2)
{
	int	n;
	int	r;

	r= -1;
	n = lstrlen(b1);
	if (n == lstrlen(b2)){
		if(lstrncmp(b1,b2,(short)n)==0){
			r=0;
		}
	}
	return(r);
}
#endif
/************************/
/* ǉ		*/
/*@߂ĺ@		*/
/************************/
void	lstrcat(char *b1,const char *b2)
{
	while(*b1 != 0){
		b1++;
	}
	while(*b2 != 0){
		*b1 = *b2;
		b1++;
		b2++;
	}
	*b1=0;
}
/****************************************/
/* 񂪑S'0'`'9'ŗL鎖	*/
/*@߂ĺ@njłO					*/
/*@@@@@@PłႤ́|P	*/
/****************************************/
int	chk_dec(const char *b1)
{
	int	r;

	r = 0;
	while(*b1 != 0){
		if ((*b1 <'0')||('9' < *b1)){
			r = -1;
			break;
		}
		b1++;
	}
	return(r);
}
/************************************************/
/* 񂪑S'0'`'9','A'`'F'ŗL鎖	*/
/*@߂ĺ@njłO							*/
/*@@@@@@PłႤ́|P			*/
/************************************************/
int	chk_hex(const char *b1)
{
	int	r;

	r = 0;
	while(*b1 != 0){
		if (('0' <= *b1)&&(*b1 <= '9')){
			;
		}else if (('A' <= *b1)&&(*b1 <= 'F')){
			;
		}else{
			r = -1;
			break;
		}
		b1++;
	}
	return(r);
}
/********************************************************/
/* iőS܂Łj畄t[hɕϊ		*/
/* ϊl߂ 									*/
/* ϊłȂL鎞ASȏ̎́|P߂ */
/********************************************************/
short	asc4tow(char *cp)
{
	short	r;
	short	i;

	r = -1;
	if(chk_dec(cp)==0){
		if (lstrlen(cp) <= 4){
			r = 0;
			for(i=0;i<4;i++){
				if (*cp == 0){
					break;
				}else{
					r *= 10;
					r += (short)(*cp - '0');
				}
				cp++;
			}
		}
	}
	return(r);
}
/********************************************************/
/* iőS܂Łj畄[hɕϊ		*/
/* ͂PUiƂ									*/
/* ϊl߂										*/
/* ϊłȂL鎞ASȏ̎́@0߂	*/
/********************************************************/
unsigned short	asch4tou(char *cp)
{
	unsigned short	r;
	short		i;
	unsigned short	c;

	r = 0;
	if(chk_hex(cp)==0){
		if (lstrlen(cp) <= 4){
			r = 0;
			for(i=0;i<4;i++){
				if (*cp == 0){
					break;
				}else{
					c = *cp;
					r *= 16;
					if (c > '9'){
						c &= ~0x20;	/* 啶 */
						c -= 7;
					}
					r += (short)(c - '0');
				}
				cp++;
			}
		}
	}
	return(r);
}

/****************************************************************/
/* PoCgf[^										*/
/* PUîQ̂`rbhhɕϊ							*/
/* ʌ̂OTvX͂Ȃ									*/
/****************************************************************/
void	wtod_02x(char *bf,unsigned char ucd)
{
	*bf = (char)(((ucd>>4) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf=0;
}
/****************************************/
/* QoCgf[^				*/
/* ŜPUî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_04x(char *bf,unsigned int ucd)
{
	*bf = (char)(((ucd>>12) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd>>8) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd>>4) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf=0;
}
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_02u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}

#if	0
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_2u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	if(*bf == '0'){
		*bf = ' ';
	}
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}
#endif

/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_05u(char *bf,unsigned int usd)
{
	int				i;
	unsigned int	cui;

	cui = 10000;
	for(i=0;i<5;i++){
		*bf = (char)('0'+(usd/cui));
		usd %= cui;
		bf++;
		cui /= 10;
	}
	*bf=0;
}
/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_5u(char *bf,unsigned int usd)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_05u(bf, usd);					// QoCgf[^T̂POî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<4;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}
//*****************************************
// (unsigned int)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned int	tasuuketu_ui(unsigned int ui0, unsigned int ui1, unsigned int ui2, unsigned int def)
{
	unsigned int	ui;

	if(ui0 == ui1){
		ui = ui0;
	}else if(ui0 == ui2){
		ui = ui0;
	}else if(ui1 == ui2){
		ui = ui1;
	}else{
		ui = def;
	}

	return(ui);
}

#if	0
//*****************************************
// (unsigned char)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned char	tasuuketu_uc(unsigned char uc0, unsigned char uc1, unsigned char uc2, unsigned char def)
{
	unsigned char	uc;

	if(uc0 == uc1){
		uc = uc0;
	}else if(uc0 == uc2){
		uc = uc0;
	}else if(uc1 == uc2){
		uc = uc1;
	}else{
		uc = def;
	}

	return(uc);
}
#endif
